/* jstools.c generated by valac 0.38.1, the Vala compiler
 * generated from jstools.vala, do not modify */

/*
 * Copyright 2011-2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <JavaScriptCore/JavaScript.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _0(var) ((var == NULL) ? NULL : (var = ( (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
#define _JSPropertyNameArrayRelease0(var) ((var == NULL) ? NULL : (var = (JSPropertyNameArrayRelease (var), NULL)))

typedef enum  {
	NUVOLA_JS_ERROR_NOT_FOUND,
	NUVOLA_JS_ERROR_WRONG_TYPE,
	NUVOLA_JS_ERROR_FUNC_FAILED,
	NUVOLA_JS_ERROR_READ_ERROR,
	NUVOLA_JS_ERROR_NO_CONTEXT,
	NUVOLA_JS_ERROR_EXCEPTION,
	NUVOLA_JS_ERROR_INITIALIZATION_FAILED
} NuvolaJSError;
#define NUVOLA_JS_ERROR nuvola_js_error_quark ()


gchar* nuvola_js_tools_utf8_string (struct OpaqueJSString* jsstring);
const struct OpaqueJSValue* nuvola_js_tools_object_from_JSON (const struct OpaqueJSContext* ctx, const gchar* json);
const struct OpaqueJSValue* nuvola_js_tools_create_exception (const struct OpaqueJSContext* ctx, const gchar* message);
gchar* nuvola_js_tools_o_get_string (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property);
gdouble nuvola_js_tools_o_get_number (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property);
void nuvola_js_tools_o_set_string (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, const gchar* value);
void nuvola_js_tools_o_set_number (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, gdouble value);
void nuvola_js_tools_o_set_null (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property);
void nuvola_js_tools_o_set_bool (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, gboolean value);
struct OpaqueJSValue* nuvola_js_tools_o_get_object (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property);
gchar* nuvola_js_tools_string_or_null (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* val, gboolean allow_empty);
gchar* nuvola_js_tools_value_to_string (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* value);
gchar* nuvola_js_tools_exception_to_string (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* value);
const struct OpaqueJSValue* nuvola_js_tools_get_gobject_property_named (const struct OpaqueJSContext* ctx, GObject* o, const gchar* name);
const struct OpaqueJSValue* nuvola_js_tools_get_gobject_property (const struct OpaqueJSContext* ctx, GObject* o, GParamSpec* p);
GQuark nuvola_js_error_quark (void);
const struct OpaqueJSValue* nuvola_js_tools_value_from_variant (const struct OpaqueJSContext* ctx, GVariant* variant, GError** error);
GVariant* nuvola_js_tools_variant_from_value (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* val, GError** error);


/**
 * Converts JavaScriptCore string to Vala UTF-8 string
 *
 * @param jsstring JavaScriptCore string
 * @return Vala UTF-8 string
 */
gchar* nuvola_js_tools_utf8_string (struct OpaqueJSString* jsstring) {
	gchar* result = NULL;
	gsize max_size = 0UL;
	struct OpaqueJSString* _tmp0_;
	gsize _tmp1_;
	guint8* buffer = NULL;
	guint8* _tmp2_;
	gint buffer_length1;
	gint _buffer_size_;
	struct OpaqueJSString* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (jsstring != NULL, NULL);
	_tmp0_ = jsstring;
	_tmp1_ = JSStringGetMaximumUTF8CStringSize (_tmp0_);
	max_size = _tmp1_;
	_tmp2_ = g_new0 (guint8, max_size);
	buffer = _tmp2_;
	buffer_length1 = max_size;
	_buffer_size_ = buffer_length1;
	_tmp3_ = jsstring;
	JSStringGetUTF8CString (_tmp3_, buffer, buffer_length1);
	_tmp4_ = g_strdup ((const gchar*) buffer);
	result = _tmp4_;
	buffer = (g_free (buffer), NULL);
	return result;
}


/**
 * Creates JavaScript object from JSON.
 * 
 * @param ctx	JavaScript context
 * @param json	object in JSON notation
 * @return	JavaScript object
 */
const struct OpaqueJSValue* nuvola_js_tools_object_from_JSON (const struct OpaqueJSContext* ctx, const gchar* json) {
	const struct OpaqueJSValue* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const struct OpaqueJSValue* _result_ = NULL;
	const struct OpaqueJSContext* _tmp3_;
	struct OpaqueJSString* _tmp4_;
	struct OpaqueJSString* _tmp5_;
	const struct OpaqueJSValue* _tmp6_;
	const struct OpaqueJSValue* _tmp7_;
	gboolean _tmp8_ = FALSE;
	const struct OpaqueJSValue* _tmp9_;
	const struct OpaqueJSValue* _tmp15_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (json != NULL, NULL);
	_tmp1_ = json;
	if (g_strcmp0 (_tmp1_, "") == 0) {
		_tmp0_ = "{}";
	} else {
		const gchar* _tmp2_;
		_tmp2_ = json;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = ctx;
	_tmp4_ = JSStringCreateWithUTF8CString (_tmp0_);
	_tmp5_ = _tmp4_;
	_tmp6_ = JSValueMakeFromJSONString (_tmp3_, _tmp5_);
	_tmp7_ = _tmp6_;
	_JSStringRelease0 (_tmp5_);
	_result_ = _tmp7_;
	_tmp9_ = _result_;
	if (_tmp9_ == NULL) {
		_tmp8_ = TRUE;
	} else {
		const struct OpaqueJSValue* _tmp10_;
		const struct OpaqueJSContext* _tmp11_;
		gboolean _tmp12_;
		_tmp10_ = _result_;
		_tmp11_ = ctx;
		_tmp12_ = JSValueIsObject (_tmp11_, _tmp10_);
		_tmp8_ = !_tmp12_;
	}
	if (_tmp8_) {
		const struct OpaqueJSContext* _tmp13_;
		struct OpaqueJSValue* _tmp14_;
		_tmp13_ = ctx;
		_tmp14_ = JSObjectMake (_tmp13_, NULL, NULL);
		_result_ = (const struct OpaqueJSValue*) _tmp14_;
	}
	_tmp15_ = _result_;
	result = _tmp15_;
	return result;
}


/**
 * Creates JavaScript Exception object.
 * 
 * @param ctx	JavaScript context
 * @param message	Error message (single line);
 * @return	JavaScript object
 */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = old;
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = old;
		_tmp4_ = replacement;
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (self);
		result = _tmp5_;
		return result;
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp6_ = old;
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		regex = _tmp10_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch20_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp12_ = regex;
		_tmp13_ = replacement;
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
		_tmp11_ = _tmp14_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch20_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp15_ = _tmp11_;
		_tmp11_ = NULL;
		result = _tmp15_;
		_g_free0 (_tmp11_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally20;
	__catch20_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally20:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


const struct OpaqueJSValue* nuvola_js_tools_create_exception (const struct OpaqueJSContext* ctx, const gchar* message) {
	const struct OpaqueJSValue* result = NULL;
	gchar* exception = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const struct OpaqueJSContext* _tmp5_;
	const struct OpaqueJSValue* _tmp6_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (message != NULL, NULL);
	_tmp0_ = message;
	_tmp1_ = string_replace (_tmp0_, "\"", "\\\"");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup_printf ("{\"type\":\"NuvolaError\", \"message\":\"%s\"}", _tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	exception = _tmp4_;
	g_debug ("jstools.vala:66: %s", exception);
	_tmp5_ = ctx;
	_tmp6_ = nuvola_js_tools_object_from_JSON (_tmp5_, exception);
	result = _tmp6_;
	_g_free0 (exception);
	return result;
}


/**
 * Obtains string property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @return string value or null if property is not a string
 */
gchar* nuvola_js_tools_o_get_string (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property) {
	gchar* result = NULL;
	const struct OpaqueJSValue* value = NULL;
	struct OpaqueJSValue* _tmp0_;
	const struct OpaqueJSContext* _tmp1_;
	const gchar* _tmp2_;
	struct OpaqueJSString* _tmp3_;
	struct OpaqueJSString* _tmp4_;
	const struct OpaqueJSValue* _tmp5_;
	const struct OpaqueJSValue* _tmp6_;
	const struct OpaqueJSValue* _tmp7_;
	const struct OpaqueJSContext* _tmp8_;
	gboolean _tmp9_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (obj != NULL, NULL);
	g_return_val_if_fail (property != NULL, NULL);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = JSObjectGetProperty (_tmp1_, _tmp0_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_JSStringRelease0 (_tmp4_);
	value = _tmp6_;
	_tmp7_ = value;
	_tmp8_ = ctx;
	_tmp9_ = JSValueIsString (_tmp8_, _tmp7_);
	if (_tmp9_) {
		const struct OpaqueJSValue* _tmp10_;
		const struct OpaqueJSContext* _tmp11_;
		struct OpaqueJSString* _tmp12_;
		struct OpaqueJSString* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp10_ = value;
		_tmp11_ = ctx;
		_tmp12_ = JSValueToStringCopy (_tmp11_, _tmp10_, NULL);
		_tmp13_ = _tmp12_;
		_tmp14_ = nuvola_js_tools_utf8_string (_tmp13_);
		_tmp15_ = _tmp14_;
		_JSStringRelease0 (_tmp13_);
		result = _tmp15_;
		return result;
	}
	result = NULL;
	return result;
}


/**
 * Obtains number property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @return double value or 0.0 if property is not a number
 */
gdouble nuvola_js_tools_o_get_number (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property) {
	gdouble result = 0.0;
	const struct OpaqueJSValue* value = NULL;
	struct OpaqueJSValue* _tmp0_;
	const struct OpaqueJSContext* _tmp1_;
	const gchar* _tmp2_;
	struct OpaqueJSString* _tmp3_;
	struct OpaqueJSString* _tmp4_;
	const struct OpaqueJSValue* _tmp5_;
	const struct OpaqueJSValue* _tmp6_;
	const struct OpaqueJSValue* _tmp7_;
	const struct OpaqueJSContext* _tmp8_;
	gboolean _tmp9_;
	g_return_val_if_fail (ctx != NULL, 0.0);
	g_return_val_if_fail (obj != NULL, 0.0);
	g_return_val_if_fail (property != NULL, 0.0);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = JSObjectGetProperty (_tmp1_, _tmp0_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_JSStringRelease0 (_tmp4_);
	value = _tmp6_;
	_tmp7_ = value;
	_tmp8_ = ctx;
	_tmp9_ = JSValueIsNumber (_tmp8_, _tmp7_);
	if (_tmp9_) {
		const struct OpaqueJSValue* _tmp10_;
		const struct OpaqueJSContext* _tmp11_;
		gdouble _tmp12_;
		_tmp10_ = value;
		_tmp11_ = ctx;
		_tmp12_ = JSValueToNumber (_tmp11_, _tmp10_, NULL);
		result = _tmp12_;
		return result;
	}
	result = 0.0;
	return result;
}


/**
 * Sets string property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @param value property value
 */
void nuvola_js_tools_o_set_string (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, const gchar* value) {
	struct OpaqueJSValue* _tmp0_;
	const struct OpaqueJSContext* _tmp1_;
	const gchar* _tmp2_;
	struct OpaqueJSString* _tmp3_;
	struct OpaqueJSString* _tmp4_;
	const struct OpaqueJSContext* _tmp5_;
	const gchar* _tmp6_;
	struct OpaqueJSString* _tmp7_;
	struct OpaqueJSString* _tmp8_;
	const struct OpaqueJSValue* _tmp9_;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (property != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = ctx;
	_tmp6_ = value;
	_tmp7_ = JSStringCreateWithUTF8CString (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = JSValueMakeString (_tmp5_, _tmp8_);
	JSObjectSetProperty (_tmp1_, _tmp0_, _tmp4_, _tmp9_, 0, NULL);
	_JSStringRelease0 (_tmp8_);
	_JSStringRelease0 (_tmp4_);
}


/**
 * Sets string property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @param value property value
 */
void nuvola_js_tools_o_set_number (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, gdouble value) {
	struct OpaqueJSValue* _tmp0_;
	const struct OpaqueJSContext* _tmp1_;
	const gchar* _tmp2_;
	struct OpaqueJSString* _tmp3_;
	struct OpaqueJSString* _tmp4_;
	const struct OpaqueJSContext* _tmp5_;
	gdouble _tmp6_;
	const struct OpaqueJSValue* _tmp7_;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = ctx;
	_tmp6_ = value;
	_tmp7_ = JSValueMakeNumber (_tmp5_, _tmp6_);
	JSObjectSetProperty (_tmp1_, _tmp0_, _tmp4_, _tmp7_, 0, NULL);
	_JSStringRelease0 (_tmp4_);
}


/**
 * Sets null property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 */
void nuvola_js_tools_o_set_null (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property) {
	struct OpaqueJSValue* _tmp0_;
	const struct OpaqueJSContext* _tmp1_;
	const gchar* _tmp2_;
	struct OpaqueJSString* _tmp3_;
	struct OpaqueJSString* _tmp4_;
	const struct OpaqueJSContext* _tmp5_;
	const struct OpaqueJSValue* _tmp6_;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = ctx;
	_tmp6_ = JSValueMakeNull (_tmp5_);
	JSObjectSetProperty (_tmp1_, _tmp0_, _tmp4_, _tmp6_, 0, NULL);
	_JSStringRelease0 (_tmp4_);
}


/**
 * Sets boolean property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @param value property value
 */
void nuvola_js_tools_o_set_bool (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, gboolean value) {
	struct OpaqueJSValue* _tmp0_;
	const struct OpaqueJSContext* _tmp1_;
	const gchar* _tmp2_;
	struct OpaqueJSString* _tmp3_;
	struct OpaqueJSString* _tmp4_;
	const struct OpaqueJSContext* _tmp5_;
	gboolean _tmp6_;
	const struct OpaqueJSValue* _tmp7_;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = ctx;
	_tmp6_ = value;
	_tmp7_ = JSValueMakeBoolean (_tmp5_, _tmp6_);
	JSObjectSetProperty (_tmp1_, _tmp0_, _tmp4_, _tmp7_, 0, NULL);
	_JSStringRelease0 (_tmp4_);
}


/**
 * Obtains object property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @return object or null if property is not a object
 */
struct OpaqueJSValue* nuvola_js_tools_o_get_object (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property) {
	struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSValue* value = NULL;
	struct OpaqueJSValue* _tmp0_;
	const struct OpaqueJSContext* _tmp1_;
	const gchar* _tmp2_;
	struct OpaqueJSString* _tmp3_;
	struct OpaqueJSString* _tmp4_;
	const struct OpaqueJSValue* _tmp5_;
	const struct OpaqueJSValue* _tmp6_;
	const struct OpaqueJSValue* _tmp7_;
	const struct OpaqueJSContext* _tmp8_;
	gboolean _tmp9_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (obj != NULL, NULL);
	g_return_val_if_fail (property != NULL, NULL);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = JSObjectGetProperty (_tmp1_, _tmp0_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_JSStringRelease0 (_tmp4_);
	value = _tmp6_;
	_tmp7_ = value;
	_tmp8_ = ctx;
	_tmp9_ = JSValueIsObject (_tmp8_, _tmp7_);
	if (_tmp9_) {
		const struct OpaqueJSValue* _tmp10_;
		const struct OpaqueJSContext* _tmp11_;
		struct OpaqueJSValue* _tmp12_;
		_tmp10_ = value;
		_tmp11_ = ctx;
		_tmp12_ = JSValueToObject (_tmp11_, _tmp10_, NULL);
		result = _tmp12_;
		return result;
	}
	result = NULL;
	return result;
}


/**
 * Converts JavaScript value to string
 * 
 * @param ctx            JavaScript context
 * @param val            JavaScript value
 * @param allow_empty    if false null will be returned for empty string
 * @return string value or null if value is not a string
 */
gchar* nuvola_js_tools_string_or_null (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* val, gboolean allow_empty) {
	gchar* result = NULL;
	const struct OpaqueJSValue* _tmp0_;
	const struct OpaqueJSContext* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (val != NULL, NULL);
	_tmp0_ = val;
	_tmp1_ = ctx;
	_tmp2_ = JSValueIsString (_tmp1_, _tmp0_);
	if (_tmp2_) {
		gchar* str = NULL;
		const struct OpaqueJSValue* _tmp3_;
		const struct OpaqueJSContext* _tmp4_;
		struct OpaqueJSString* _tmp5_;
		struct OpaqueJSString* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
		gchar* _tmp14_;
		_tmp3_ = val;
		_tmp4_ = ctx;
		_tmp5_ = JSValueToStringCopy (_tmp4_, _tmp3_, NULL);
		_tmp6_ = _tmp5_;
		_tmp7_ = nuvola_js_tools_utf8_string (_tmp6_);
		_tmp8_ = _tmp7_;
		_JSStringRelease0 (_tmp6_);
		str = _tmp8_;
		_tmp11_ = str;
		if (g_strcmp0 (_tmp11_, "") == 0) {
			gboolean _tmp12_;
			_tmp12_ = allow_empty;
			_tmp10_ = !_tmp12_;
		} else {
			_tmp10_ = FALSE;
		}
		if (_tmp10_) {
			_tmp9_ = NULL;
		} else {
			const gchar* _tmp13_;
			_tmp13_ = str;
			_tmp9_ = _tmp13_;
		}
		_tmp14_ = g_strdup (_tmp9_);
		result = _tmp14_;
		_g_free0 (str);
		return result;
	}
	result = NULL;
	return result;
}


static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}


gchar* nuvola_js_tools_value_to_string (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* value) {
	gchar* result = NULL;
	const struct OpaqueJSValue* _tmp0_;
	const struct OpaqueJSContext* _tmp1_;
	gboolean _tmp2_;
	const struct OpaqueJSValue* _tmp9_;
	const struct OpaqueJSContext* _tmp10_;
	gboolean _tmp11_;
	const struct OpaqueJSValue* _tmp16_;
	const struct OpaqueJSContext* _tmp17_;
	gboolean _tmp18_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	_tmp0_ = value;
	_tmp1_ = ctx;
	_tmp2_ = JSValueIsString (_tmp1_, _tmp0_);
	if (_tmp2_) {
		const struct OpaqueJSValue* _tmp3_;
		const struct OpaqueJSContext* _tmp4_;
		struct OpaqueJSString* _tmp5_;
		struct OpaqueJSString* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp3_ = value;
		_tmp4_ = ctx;
		_tmp5_ = JSValueToStringCopy (_tmp4_, _tmp3_, NULL);
		_tmp6_ = _tmp5_;
		_tmp7_ = nuvola_js_tools_utf8_string (_tmp6_);
		_tmp8_ = _tmp7_;
		_JSStringRelease0 (_tmp6_);
		result = _tmp8_;
		return result;
	}
	_tmp9_ = value;
	_tmp10_ = ctx;
	_tmp11_ = JSValueIsNumber (_tmp10_, _tmp9_);
	if (_tmp11_) {
		const struct OpaqueJSValue* _tmp12_;
		const struct OpaqueJSContext* _tmp13_;
		gdouble _tmp14_;
		gchar* _tmp15_;
		_tmp12_ = value;
		_tmp13_ = ctx;
		_tmp14_ = JSValueToNumber (_tmp13_, _tmp12_, NULL);
		_tmp15_ = double_to_string (_tmp14_);
		result = _tmp15_;
		return result;
	}
	_tmp16_ = value;
	_tmp17_ = ctx;
	_tmp18_ = JSValueIsObject (_tmp17_, _tmp16_);
	if (_tmp18_) {
		const struct OpaqueJSValue* _tmp19_;
		const struct OpaqueJSContext* _tmp20_;
		struct OpaqueJSValue* _tmp21_;
		const struct OpaqueJSContext* _tmp22_;
		struct OpaqueJSString* _tmp23_;
		struct OpaqueJSString* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp19_ = value;
		_tmp20_ = ctx;
		_tmp21_ = JSValueToObject (_tmp20_, _tmp19_, NULL);
		_tmp22_ = ctx;
		_tmp23_ = JSValueCreateJSONString (_tmp22_, (const struct OpaqueJSValue*) _tmp21_, (guint) 0, NULL);
		_tmp24_ = _tmp23_;
		_tmp25_ = nuvola_js_tools_utf8_string (_tmp24_);
		_tmp26_ = _tmp25_;
		_JSStringRelease0 (_tmp24_);
		result = _tmp26_;
		return result;
	}
	result = NULL;
	return result;
}


gchar* nuvola_js_tools_exception_to_string (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* value) {
	gchar* result = NULL;
	const struct OpaqueJSValue* _tmp0_;
	const struct OpaqueJSContext* _tmp1_;
	gboolean _tmp2_;
	const struct OpaqueJSContext* _tmp33_;
	const struct OpaqueJSValue* _tmp34_;
	gchar* _tmp35_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	_tmp0_ = value;
	_tmp1_ = ctx;
	_tmp2_ = JSValueIsObject (_tmp1_, _tmp0_);
	if (_tmp2_) {
		struct OpaqueJSValue* obj = NULL;
		const struct OpaqueJSValue* _tmp3_;
		const struct OpaqueJSContext* _tmp4_;
		struct OpaqueJSValue* _tmp5_;
		gchar* message = NULL;
		const struct OpaqueJSContext* _tmp6_;
		struct OpaqueJSValue* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		_tmp3_ = value;
		_tmp4_ = ctx;
		_tmp5_ = JSValueToObject (_tmp4_, _tmp3_, NULL);
		obj = _tmp5_;
		_tmp6_ = ctx;
		_tmp7_ = obj;
		_tmp8_ = nuvola_js_tools_o_get_string (_tmp6_, _tmp7_, "message");
		message = _tmp8_;
		_tmp9_ = message;
		if (_tmp9_ != NULL) {
			gchar* name = NULL;
			const struct OpaqueJSContext* _tmp10_;
			struct OpaqueJSValue* _tmp11_;
			gchar* _tmp12_;
			gint line = 0;
			const struct OpaqueJSContext* _tmp13_;
			struct OpaqueJSValue* _tmp14_;
			gdouble _tmp15_;
			gchar* file = NULL;
			const struct OpaqueJSContext* _tmp16_;
			struct OpaqueJSValue* _tmp17_;
			gchar* _tmp18_;
			gboolean _tmp19_ = FALSE;
			gint _tmp20_;
			const gchar* _tmp26_ = NULL;
			const gchar* _tmp27_;
			const gchar* _tmp28_ = NULL;
			const gchar* _tmp29_;
			gint _tmp30_;
			const gchar* _tmp31_;
			gchar* _tmp32_;
			_tmp10_ = ctx;
			_tmp11_ = obj;
			_tmp12_ = nuvola_js_tools_o_get_string (_tmp10_, _tmp11_, "name");
			name = _tmp12_;
			_tmp13_ = ctx;
			_tmp14_ = obj;
			_tmp15_ = nuvola_js_tools_o_get_number (_tmp13_, _tmp14_, "line");
			line = (gint) _tmp15_;
			_tmp16_ = ctx;
			_tmp17_ = obj;
			_tmp18_ = nuvola_js_tools_o_get_string (_tmp16_, _tmp17_, "sourceURL");
			file = _tmp18_;
			_tmp20_ = line;
			if (_tmp20_ == 0) {
				const gchar* _tmp21_;
				_tmp21_ = file;
				_tmp19_ = _tmp21_ == NULL;
			} else {
				_tmp19_ = FALSE;
			}
			if (_tmp19_) {
				const gchar* _tmp22_ = NULL;
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				_tmp23_ = name;
				_tmp22_ = _tmp23_;
				if (_tmp22_ == NULL) {
					_tmp22_ = "null";
				}
				_tmp24_ = message;
				_tmp25_ = g_strdup_printf ("%s: %s. Enable JS debugging for more details.", _tmp22_, _tmp24_);
				result = _tmp25_;
				_g_free0 (file);
				_g_free0 (name);
				_g_free0 (message);
				return result;
			}
			_tmp27_ = file;
			_tmp26_ = _tmp27_;
			if (_tmp26_ == NULL) {
				_tmp26_ = "(null)";
			}
			_tmp29_ = name;
			_tmp28_ = _tmp29_;
			if (_tmp28_ == NULL) {
				_tmp28_ = "null";
			}
			_tmp30_ = line;
			_tmp31_ = message;
			_tmp32_ = g_strdup_printf ("%s:%d: %s: %s", _tmp26_, _tmp30_, _tmp28_, _tmp31_);
			result = _tmp32_;
			_g_free0 (file);
			_g_free0 (name);
			_g_free0 (message);
			return result;
		}
		_g_free0 (message);
	}
	_tmp33_ = ctx;
	_tmp34_ = value;
	_tmp35_ = nuvola_js_tools_value_to_string (_tmp33_, _tmp34_);
	result = _tmp35_;
	return result;
}


const struct OpaqueJSValue* nuvola_js_tools_get_gobject_property_named (const struct OpaqueJSContext* ctx, GObject* o, const gchar* name) {
	const struct OpaqueJSValue* result = NULL;
	GObjectClass* klass = NULL;
	GObject* _tmp0_;
	GType _tmp1_;
	GTypeClass* _tmp2_;
	GParamSpec* p = NULL;
	GObjectClass* _tmp3_;
	const gchar* _tmp4_;
	GParamSpec* _tmp5_;
	GParamSpec* _tmp6_;
	const struct OpaqueJSContext* _tmp9_;
	GObject* _tmp10_;
	GParamSpec* _tmp11_;
	const struct OpaqueJSValue* _tmp12_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (o != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = o;
	_tmp1_ = G_TYPE_FROM_INSTANCE (_tmp0_);
	_tmp2_ = g_type_class_ref (_tmp1_);
	klass = (GObjectClass*) _tmp2_;
	_tmp3_ = klass;
	_tmp4_ = name;
	_tmp5_ = g_object_class_find_property (_tmp3_, _tmp4_);
	p = _tmp5_;
	_tmp6_ = p;
	if (_tmp6_ == NULL) {
		const struct OpaqueJSContext* _tmp7_;
		const struct OpaqueJSValue* _tmp8_;
		_tmp7_ = ctx;
		_tmp8_ = JSValueMakeUndefined (_tmp7_);
		result = _tmp8_;
		_g_type_class_unref0 (klass);
		return result;
	}
	_tmp9_ = ctx;
	_tmp10_ = o;
	_tmp11_ = p;
	_tmp12_ = nuvola_js_tools_get_gobject_property (_tmp9_, _tmp10_, _tmp11_);
	result = _tmp12_;
	_g_type_class_unref0 (klass);
	return result;
}


const struct OpaqueJSValue* nuvola_js_tools_get_gobject_property (const struct OpaqueJSContext* ctx, GObject* o, GParamSpec* p) {
	const struct OpaqueJSValue* result = NULL;
	GType type = 0UL;
	GParamSpec* _tmp0_;
	GType _tmp1_;
	GType _tmp2_;
	GType _tmp12_;
	GType _tmp19_;
	GType _tmp26_;
	GType _tmp33_;
	const struct OpaqueJSContext* _tmp40_;
	const struct OpaqueJSValue* _tmp41_;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (o != NULL, NULL);
	g_return_val_if_fail (p != NULL, NULL);
	_tmp0_ = p;
	_tmp1_ = _tmp0_->value_type;
	type = _tmp1_;
	_tmp2_ = type;
	if (_tmp2_ == G_TYPE_STRING) {
		gchar* str_val = NULL;
		GObject* _tmp3_;
		GParamSpec* _tmp4_;
		const gchar* _tmp5_;
		const struct OpaqueJSContext* _tmp6_;
		const gchar* _tmp7_;
		struct OpaqueJSString* _tmp8_;
		struct OpaqueJSString* _tmp9_;
		const struct OpaqueJSValue* _tmp10_;
		const struct OpaqueJSValue* _tmp11_;
		_tmp3_ = o;
		_tmp4_ = p;
		_tmp5_ = _tmp4_->name;
		g_object_get (_tmp3_, _tmp5_, &str_val, NULL);
		_tmp6_ = ctx;
		_tmp7_ = str_val;
		_tmp8_ = JSStringCreateWithUTF8CString (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = JSValueMakeString (_tmp6_, _tmp9_);
		_tmp11_ = _tmp10_;
		_JSStringRelease0 (_tmp9_);
		result = _tmp11_;
		_g_free0 (str_val);
		return result;
	}
	_tmp12_ = type;
	if (_tmp12_ == G_TYPE_INT) {
		gint int_val = 0;
		GObject* _tmp13_;
		GParamSpec* _tmp14_;
		const gchar* _tmp15_;
		const struct OpaqueJSContext* _tmp16_;
		gint _tmp17_;
		const struct OpaqueJSValue* _tmp18_;
		_tmp13_ = o;
		_tmp14_ = p;
		_tmp15_ = _tmp14_->name;
		g_object_get (_tmp13_, _tmp15_, &int_val, NULL);
		_tmp16_ = ctx;
		_tmp17_ = int_val;
		_tmp18_ = JSValueMakeNumber (_tmp16_, (gdouble) _tmp17_);
		result = _tmp18_;
		return result;
	}
	_tmp19_ = type;
	if (_tmp19_ == G_TYPE_FLOAT) {
		gfloat float_val = 0.0F;
		GObject* _tmp20_;
		GParamSpec* _tmp21_;
		const gchar* _tmp22_;
		const struct OpaqueJSContext* _tmp23_;
		gfloat _tmp24_;
		const struct OpaqueJSValue* _tmp25_;
		_tmp20_ = o;
		_tmp21_ = p;
		_tmp22_ = _tmp21_->name;
		g_object_get (_tmp20_, _tmp22_, &float_val, NULL);
		_tmp23_ = ctx;
		_tmp24_ = float_val;
		_tmp25_ = JSValueMakeNumber (_tmp23_, (gdouble) _tmp24_);
		result = _tmp25_;
		return result;
	}
	_tmp26_ = type;
	if (_tmp26_ == G_TYPE_DOUBLE) {
		gdouble double_val = 0.0;
		GObject* _tmp27_;
		GParamSpec* _tmp28_;
		const gchar* _tmp29_;
		const struct OpaqueJSContext* _tmp30_;
		gdouble _tmp31_;
		const struct OpaqueJSValue* _tmp32_;
		_tmp27_ = o;
		_tmp28_ = p;
		_tmp29_ = _tmp28_->name;
		g_object_get (_tmp27_, _tmp29_, &double_val, NULL);
		_tmp30_ = ctx;
		_tmp31_ = double_val;
		_tmp32_ = JSValueMakeNumber (_tmp30_, (gdouble) _tmp31_);
		result = _tmp32_;
		return result;
	}
	_tmp33_ = type;
	if (_tmp33_ == G_TYPE_BOOLEAN) {
		gboolean bool_val = FALSE;
		GObject* _tmp34_;
		GParamSpec* _tmp35_;
		const gchar* _tmp36_;
		const struct OpaqueJSContext* _tmp37_;
		gboolean _tmp38_;
		const struct OpaqueJSValue* _tmp39_;
		_tmp34_ = o;
		_tmp35_ = p;
		_tmp36_ = _tmp35_->name;
		g_object_get (_tmp34_, _tmp36_, &bool_val, NULL);
		_tmp37_ = ctx;
		_tmp38_ = bool_val;
		_tmp39_ = JSValueMakeBoolean (_tmp37_, _tmp38_);
		result = _tmp39_;
		return result;
	}
	_tmp40_ = ctx;
	_tmp41_ = JSValueMakeUndefined (_tmp40_);
	result = _tmp41_;
	return result;
}


static gpointer _g_variant_type_copy0 (gpointer self) {
	return self ? g_variant_type_copy (self) : NULL;
}


const struct OpaqueJSValue* nuvola_js_tools_value_from_variant (const struct OpaqueJSContext* ctx, GVariant* variant, GError** error) {
	const struct OpaqueJSValue* result = NULL;
	GVariant* _tmp0_;
	GVariantType* type = NULL;
	GVariant* _tmp3_;
	const GVariantType* _tmp4_;
	GVariantType* _tmp5_;
	GVariant* _tmp6_;
	const GVariantType* _tmp7_;
	gboolean _tmp8_;
	const GVariantType* _tmp16_;
	const GVariantType* _tmp17_;
	gboolean _tmp18_;
	GVariantType* object_type = NULL;
	GVariantType* _tmp27_;
	const GVariantType* _tmp28_;
	const GVariantType* _tmp29_;
	gboolean _tmp30_;
	GVariant* _tmp46_;
	const GVariantType* _tmp47_;
	gboolean _tmp48_;
	GVariant* _tmp56_;
	const GVariantType* _tmp57_;
	gboolean _tmp58_;
	GVariant* _tmp63_;
	const GVariantType* _tmp64_;
	gboolean _tmp65_;
	GVariant* _tmp70_;
	const GVariantType* _tmp71_;
	gboolean _tmp72_;
	GVariant* _tmp77_;
	const GVariantType* _tmp78_;
	gboolean _tmp79_;
	GVariant* _tmp84_;
	const GVariantType* _tmp85_;
	gboolean _tmp86_;
	GVariant* _tmp91_;
	const GVariantType* _tmp92_;
	gboolean _tmp93_;
	GVariant* _tmp98_;
	gboolean _tmp99_;
	GVariant* _tmp122_;
	const gchar* _tmp123_;
	GVariant* _tmp124_;
	gchar* _tmp125_;
	gchar* _tmp126_;
	GError* _tmp127_;
	GError* _tmp128_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	_tmp0_ = variant;
	if (_tmp0_ == NULL) {
		const struct OpaqueJSContext* _tmp1_;
		const struct OpaqueJSValue* _tmp2_;
		_tmp1_ = ctx;
		_tmp2_ = JSValueMakeNull (_tmp1_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = variant;
	_tmp4_ = g_variant_get_type (_tmp3_);
	_tmp5_ = _g_variant_type_copy0 (_tmp4_);
	type = _tmp5_;
	_tmp6_ = variant;
	_tmp7_ = G_VARIANT_TYPE_VARIANT;
	_tmp8_ = g_variant_is_of_type (_tmp6_, _tmp7_);
	if (_tmp8_) {
		const struct OpaqueJSValue* _tmp9_ = NULL;
		const struct OpaqueJSContext* _tmp10_;
		GVariant* _tmp11_;
		GVariant* _tmp12_;
		GVariant* _tmp13_;
		const struct OpaqueJSValue* _tmp14_;
		const struct OpaqueJSValue* _tmp15_;
		_tmp10_ = ctx;
		_tmp11_ = variant;
		_tmp12_ = g_variant_get_variant (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = nuvola_js_tools_value_from_variant (_tmp10_, _tmp13_, &_inner_error_);
		_tmp15_ = _tmp14_;
		_g_variant_unref0 (_tmp13_);
		_tmp9_ = _tmp15_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == NUVOLA_JS_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_variant_type_free0 (type);
				return NULL;
			} else {
				_g_variant_type_free0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		result = _tmp9_;
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp16_ = type;
	_tmp17_ = G_VARIANT_TYPE_MAYBE;
	_tmp18_ = g_variant_type_is_subtype_of (_tmp16_, _tmp17_);
	if (_tmp18_) {
		GVariant* maybe_variant = NULL;
		GVariant* _tmp19_;
		GVariant* _tmp20_;
		const struct OpaqueJSValue* _tmp23_ = NULL;
		const struct OpaqueJSContext* _tmp24_;
		GVariant* _tmp25_;
		const struct OpaqueJSValue* _tmp26_;
		maybe_variant = NULL;
		_tmp19_ = variant;
		g_variant_get (_tmp19_, "m*", &maybe_variant, NULL);
		_tmp20_ = maybe_variant;
		if (_tmp20_ == NULL) {
			const struct OpaqueJSContext* _tmp21_;
			const struct OpaqueJSValue* _tmp22_;
			_tmp21_ = ctx;
			_tmp22_ = JSValueMakeNull (_tmp21_);
			result = _tmp22_;
			_g_variant_unref0 (maybe_variant);
			_g_variant_type_free0 (type);
			return result;
		}
		_tmp24_ = ctx;
		_tmp25_ = maybe_variant;
		_tmp26_ = nuvola_js_tools_value_from_variant (_tmp24_, _tmp25_, &_inner_error_);
		_tmp23_ = _tmp26_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == NUVOLA_JS_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_variant_unref0 (maybe_variant);
				_g_variant_type_free0 (type);
				return NULL;
			} else {
				_g_variant_unref0 (maybe_variant);
				_g_variant_type_free0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		result = _tmp23_;
		_g_variant_unref0 (maybe_variant);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp27_ = g_variant_type_new ("a{s*}");
	object_type = _tmp27_;
	_tmp28_ = type;
	_tmp29_ = object_type;
	_tmp30_ = g_variant_type_is_subtype_of (_tmp28_, _tmp29_);
	if (_tmp30_) {
		struct OpaqueJSValue* object = NULL;
		const struct OpaqueJSContext* _tmp31_;
		struct OpaqueJSValue* _tmp32_;
		GVariantIter* iter = NULL;
		GVariant* _tmp33_;
		gchar* key = NULL;
		GVariant* value = NULL;
		struct OpaqueJSValue* _tmp45_;
		_tmp31_ = ctx;
		_tmp32_ = JSObjectMake (_tmp31_, NULL, NULL);
		object = _tmp32_;
		iter = NULL;
		_tmp33_ = variant;
		g_variant_get (_tmp33_, "a{s*}", &iter, NULL);
		key = NULL;
		value = NULL;
		while (TRUE) {
			GVariantIter* _tmp34_;
			gboolean _tmp35_;
			const struct OpaqueJSValue* _tmp36_ = NULL;
			const struct OpaqueJSContext* _tmp37_;
			GVariant* _tmp38_;
			const struct OpaqueJSValue* _tmp39_;
			struct OpaqueJSValue* _tmp40_;
			const struct OpaqueJSContext* _tmp41_;
			const gchar* _tmp42_;
			struct OpaqueJSString* _tmp43_;
			struct OpaqueJSString* _tmp44_;
			_tmp34_ = iter;
			_tmp35_ = g_variant_iter_next (_tmp34_, "{s*}", &key, &value, NULL);
			if (!_tmp35_) {
				break;
			}
			_tmp37_ = ctx;
			_tmp38_ = value;
			_tmp39_ = nuvola_js_tools_value_from_variant (_tmp37_, _tmp38_, &_inner_error_);
			_tmp36_ = _tmp39_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == NUVOLA_JS_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_variant_unref0 (value);
					_g_free0 (key);
					_g_variant_iter_free0 (iter);
					_g_variant_type_free0 (object_type);
					_g_variant_type_free0 (type);
					return NULL;
				} else {
					_g_variant_unref0 (value);
					_g_free0 (key);
					_g_variant_iter_free0 (iter);
					_g_variant_type_free0 (object_type);
					_g_variant_type_free0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			_tmp40_ = object;
			_tmp41_ = ctx;
			_tmp42_ = key;
			_tmp43_ = JSStringCreateWithUTF8CString (_tmp42_);
			_tmp44_ = _tmp43_;
			JSObjectSetProperty (_tmp41_, _tmp40_, _tmp44_, _tmp36_, 0, NULL);
			_JSStringRelease0 (_tmp44_);
		}
		_tmp45_ = object;
		result = (const struct OpaqueJSValue*) _tmp45_;
		_g_variant_unref0 (value);
		_g_free0 (key);
		_g_variant_iter_free0 (iter);
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp46_ = variant;
	_tmp47_ = G_VARIANT_TYPE_STRING;
	_tmp48_ = g_variant_is_of_type (_tmp46_, _tmp47_);
	if (_tmp48_) {
		const struct OpaqueJSContext* _tmp49_;
		GVariant* _tmp50_;
		const gchar* _tmp51_;
		struct OpaqueJSString* _tmp52_;
		struct OpaqueJSString* _tmp53_;
		const struct OpaqueJSValue* _tmp54_;
		const struct OpaqueJSValue* _tmp55_;
		_tmp49_ = ctx;
		_tmp50_ = variant;
		_tmp51_ = g_variant_get_string (_tmp50_, NULL);
		_tmp52_ = JSStringCreateWithUTF8CString (_tmp51_);
		_tmp53_ = _tmp52_;
		_tmp54_ = JSValueMakeString (_tmp49_, _tmp53_);
		_tmp55_ = _tmp54_;
		_JSStringRelease0 (_tmp53_);
		result = _tmp55_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp56_ = variant;
	_tmp57_ = G_VARIANT_TYPE_BOOLEAN;
	_tmp58_ = g_variant_is_of_type (_tmp56_, _tmp57_);
	if (_tmp58_) {
		const struct OpaqueJSContext* _tmp59_;
		GVariant* _tmp60_;
		gboolean _tmp61_;
		const struct OpaqueJSValue* _tmp62_;
		_tmp59_ = ctx;
		_tmp60_ = variant;
		_tmp61_ = g_variant_get_boolean (_tmp60_);
		_tmp62_ = JSValueMakeBoolean (_tmp59_, _tmp61_);
		result = _tmp62_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp63_ = variant;
	_tmp64_ = G_VARIANT_TYPE_DOUBLE;
	_tmp65_ = g_variant_is_of_type (_tmp63_, _tmp64_);
	if (_tmp65_) {
		const struct OpaqueJSContext* _tmp66_;
		GVariant* _tmp67_;
		gdouble _tmp68_;
		const struct OpaqueJSValue* _tmp69_;
		_tmp66_ = ctx;
		_tmp67_ = variant;
		_tmp68_ = g_variant_get_double (_tmp67_);
		_tmp69_ = JSValueMakeNumber (_tmp66_, _tmp68_);
		result = _tmp69_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp70_ = variant;
	_tmp71_ = G_VARIANT_TYPE_INT32;
	_tmp72_ = g_variant_is_of_type (_tmp70_, _tmp71_);
	if (_tmp72_) {
		const struct OpaqueJSContext* _tmp73_;
		GVariant* _tmp74_;
		gint32 _tmp75_;
		const struct OpaqueJSValue* _tmp76_;
		_tmp73_ = ctx;
		_tmp74_ = variant;
		_tmp75_ = g_variant_get_int32 (_tmp74_);
		_tmp76_ = JSValueMakeNumber (_tmp73_, (gdouble) _tmp75_);
		result = _tmp76_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp77_ = variant;
	_tmp78_ = G_VARIANT_TYPE_UINT32;
	_tmp79_ = g_variant_is_of_type (_tmp77_, _tmp78_);
	if (_tmp79_) {
		const struct OpaqueJSContext* _tmp80_;
		GVariant* _tmp81_;
		guint32 _tmp82_;
		const struct OpaqueJSValue* _tmp83_;
		_tmp80_ = ctx;
		_tmp81_ = variant;
		_tmp82_ = g_variant_get_uint32 (_tmp81_);
		_tmp83_ = JSValueMakeNumber (_tmp80_, (gdouble) _tmp82_);
		result = _tmp83_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp84_ = variant;
	_tmp85_ = G_VARIANT_TYPE_INT64;
	_tmp86_ = g_variant_is_of_type (_tmp84_, _tmp85_);
	if (_tmp86_) {
		const struct OpaqueJSContext* _tmp87_;
		GVariant* _tmp88_;
		gint64 _tmp89_;
		const struct OpaqueJSValue* _tmp90_;
		_tmp87_ = ctx;
		_tmp88_ = variant;
		_tmp89_ = g_variant_get_int64 (_tmp88_);
		_tmp90_ = JSValueMakeNumber (_tmp87_, (gdouble) _tmp89_);
		result = _tmp90_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp91_ = variant;
	_tmp92_ = G_VARIANT_TYPE_UINT64;
	_tmp93_ = g_variant_is_of_type (_tmp91_, _tmp92_);
	if (_tmp93_) {
		const struct OpaqueJSContext* _tmp94_;
		GVariant* _tmp95_;
		guint64 _tmp96_;
		const struct OpaqueJSValue* _tmp97_;
		_tmp94_ = ctx;
		_tmp95_ = variant;
		_tmp96_ = g_variant_get_uint64 (_tmp95_);
		_tmp97_ = JSValueMakeNumber (_tmp94_, (gdouble) _tmp96_);
		result = _tmp97_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp98_ = variant;
	_tmp99_ = g_variant_is_container (_tmp98_);
	if (_tmp99_) {
		gsize size = 0UL;
		GVariant* _tmp100_;
		gsize _tmp101_;
		void** args = NULL;
		gsize _tmp102_;
		void** _tmp103_;
		gint args_length1;
		gint _args_size_;
		const struct OpaqueJSContext* _tmp119_;
		void** _tmp120_;
		gint _tmp120__length1;
		struct OpaqueJSValue* _tmp121_;
		_tmp100_ = variant;
		_tmp101_ = g_variant_n_children (_tmp100_);
		size = _tmp101_;
		_tmp102_ = size;
		_tmp103_ = g_new0 (void*, _tmp102_);
		args = _tmp103_;
		args_length1 = _tmp102_;
		_args_size_ = args_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp104_ = FALSE;
				_tmp104_ = TRUE;
				while (TRUE) {
					gint _tmp106_;
					gsize _tmp107_;
					const struct OpaqueJSValue* _tmp108_ = NULL;
					const struct OpaqueJSContext* _tmp109_;
					GVariant* _tmp110_;
					gint _tmp111_;
					GVariant* _tmp112_;
					GVariant* _tmp113_;
					const struct OpaqueJSValue* _tmp114_;
					const struct OpaqueJSValue* _tmp115_;
					void** _tmp116_;
					gint _tmp116__length1;
					gint _tmp117_;
					void* _tmp118_;
					if (!_tmp104_) {
						gint _tmp105_;
						_tmp105_ = i;
						i = _tmp105_ + 1;
					}
					_tmp104_ = FALSE;
					_tmp106_ = i;
					_tmp107_ = size;
					if (!(((gsize) _tmp106_) < _tmp107_)) {
						break;
					}
					_tmp109_ = ctx;
					_tmp110_ = variant;
					_tmp111_ = i;
					_tmp112_ = g_variant_get_child_value (_tmp110_, (gsize) _tmp111_);
					_tmp113_ = _tmp112_;
					_tmp114_ = nuvola_js_tools_value_from_variant (_tmp109_, _tmp113_, &_inner_error_);
					_tmp115_ = _tmp114_;
					_g_variant_unref0 (_tmp113_);
					_tmp108_ = _tmp115_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == NUVOLA_JS_ERROR) {
							g_propagate_error (error, _inner_error_);
							args = (g_free (args), NULL);
							_g_variant_type_free0 (object_type);
							_g_variant_type_free0 (type);
							return NULL;
						} else {
							args = (g_free (args), NULL);
							_g_variant_type_free0 (object_type);
							_g_variant_type_free0 (type);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
					_tmp116_ = args;
					_tmp116__length1 = args_length1;
					_tmp117_ = i;
					_tmp116_[_tmp117_] = (void*) _tmp108_;
					_tmp118_ = _tmp116_[_tmp117_];
				}
			}
		}
		_tmp119_ = ctx;
		_tmp120_ = args;
		_tmp120__length1 = args_length1;
		_tmp121_ = JSObjectMakeArray (_tmp119_, (size_t) ((_tmp120__length1 * sizeof (void*)) / sizeof (const struct OpaqueJSValue*)), (const struct OpaqueJSValue**) _tmp120_, NULL);
		result = (const struct OpaqueJSValue*) _tmp121_;
		args = (g_free (args), NULL);
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp122_ = variant;
	_tmp123_ = g_variant_get_type_string (_tmp122_);
	_tmp124_ = variant;
	_tmp125_ = g_variant_print (_tmp124_, TRUE);
	_tmp126_ = _tmp125_;
	_tmp127_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_WRONG_TYPE, "Unsupported type '%s'. Content: %s", _tmp123_, _tmp126_);
	_tmp128_ = _tmp127_;
	_g_free0 (_tmp126_);
	_inner_error_ = _tmp128_;
	if (_inner_error_->domain == NUVOLA_JS_ERROR) {
		g_propagate_error (error, _inner_error_);
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return NULL;
	} else {
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_variant_type_free0 (object_type);
	_g_variant_type_free0 (type);
}


GVariant* nuvola_js_tools_variant_from_value (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* val, GError** error) {
	GVariant* result = NULL;
	const struct OpaqueJSValue* _tmp0_;
	const struct OpaqueJSContext* _tmp1_;
	gboolean _tmp2_;
	const struct OpaqueJSValue* _tmp4_;
	const struct OpaqueJSContext* _tmp5_;
	gboolean _tmp6_;
	const struct OpaqueJSValue* _tmp15_;
	const struct OpaqueJSContext* _tmp16_;
	gboolean _tmp17_;
	const struct OpaqueJSValue* _tmp22_;
	const struct OpaqueJSContext* _tmp23_;
	gboolean _tmp24_;
	struct OpaqueJSValue* glob_object = NULL;
	const struct OpaqueJSContext* _tmp29_;
	struct OpaqueJSValue* _tmp30_;
	struct OpaqueJSValue* object = NULL;
	const struct OpaqueJSContext* _tmp31_;
	struct OpaqueJSValue* _tmp32_;
	struct OpaqueJSValue* _tmp33_;
	const struct OpaqueJSContext* _tmp34_;
	struct OpaqueJSValue* _tmp35_;
	struct OpaqueJSValue* _tmp36_;
	void** params = NULL;
	void** _tmp37_;
	gint params_length1;
	gint _params_size_;
	void** _tmp38_;
	gint _tmp38__length1;
	const struct OpaqueJSValue* _tmp39_;
	void* _tmp40_;
	const struct OpaqueJSValue* exception = NULL;
	const struct OpaqueJSValue* _result_ = NULL;
	struct OpaqueJSValue* _tmp41_;
	const struct OpaqueJSContext* _tmp42_;
	struct OpaqueJSValue* _tmp43_;
	void** _tmp44_;
	gint _tmp44__length1;
	const struct OpaqueJSValue* _tmp45_ = NULL;
	const struct OpaqueJSValue* _tmp46_;
	const struct OpaqueJSValue* _tmp47_;
	const struct OpaqueJSValue* _tmp54_;
	const struct OpaqueJSContext* _tmp55_;
	gboolean _tmp56_;
	const struct OpaqueJSValue* _tmp79_;
	const struct OpaqueJSContext* _tmp80_;
	gboolean _tmp81_;
	GVariant* _tmp112_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (val != NULL, NULL);
	_tmp0_ = val;
	_tmp1_ = ctx;
	_tmp2_ = JSValueIsNull (_tmp1_, _tmp0_);
	if (_tmp2_) {
		GVariant* _tmp3_;
		_tmp3_ = g_variant_new ("mv", NULL, NULL);
		g_variant_ref_sink (_tmp3_);
		result = _tmp3_;
		return result;
	}
	_tmp4_ = val;
	_tmp5_ = ctx;
	_tmp6_ = JSValueIsString (_tmp5_, _tmp4_);
	if (_tmp6_) {
		const struct OpaqueJSValue* _tmp7_;
		const struct OpaqueJSContext* _tmp8_;
		struct OpaqueJSString* _tmp9_;
		struct OpaqueJSString* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GVariant* _tmp13_;
		GVariant* _tmp14_;
		_tmp7_ = val;
		_tmp8_ = ctx;
		_tmp9_ = JSValueToStringCopy (_tmp8_, _tmp7_, NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = nuvola_js_tools_utf8_string (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_variant_new_string (_tmp12_);
		g_variant_ref_sink (_tmp13_);
		_tmp14_ = _tmp13_;
		_g_free0 (_tmp12_);
		_JSStringRelease0 (_tmp10_);
		result = _tmp14_;
		return result;
	}
	_tmp15_ = val;
	_tmp16_ = ctx;
	_tmp17_ = JSValueIsNumber (_tmp16_, _tmp15_);
	if (_tmp17_) {
		const struct OpaqueJSValue* _tmp18_;
		const struct OpaqueJSContext* _tmp19_;
		gdouble _tmp20_;
		GVariant* _tmp21_;
		_tmp18_ = val;
		_tmp19_ = ctx;
		_tmp20_ = JSValueToNumber (_tmp19_, _tmp18_, NULL);
		_tmp21_ = g_variant_new_double (_tmp20_);
		g_variant_ref_sink (_tmp21_);
		result = _tmp21_;
		return result;
	}
	_tmp22_ = val;
	_tmp23_ = ctx;
	_tmp24_ = JSValueIsBoolean (_tmp23_, _tmp22_);
	if (_tmp24_) {
		const struct OpaqueJSValue* _tmp25_;
		const struct OpaqueJSContext* _tmp26_;
		gboolean _tmp27_;
		GVariant* _tmp28_;
		_tmp25_ = val;
		_tmp26_ = ctx;
		_tmp27_ = JSValueToBoolean (_tmp26_, _tmp25_);
		_tmp28_ = g_variant_new_boolean (_tmp27_);
		g_variant_ref_sink (_tmp28_);
		result = _tmp28_;
		return result;
	}
	_tmp29_ = ctx;
	_tmp30_ = JSContextGetGlobalObject (_tmp29_);
	glob_object = _tmp30_;
	_tmp31_ = ctx;
	_tmp32_ = glob_object;
	_tmp33_ = nuvola_js_tools_o_get_object (_tmp31_, _tmp32_, "Array");
	object = _tmp33_;
	_tmp34_ = ctx;
	_tmp35_ = object;
	_tmp36_ = nuvola_js_tools_o_get_object (_tmp34_, _tmp35_, "isArray");
	object = _tmp36_;
	_tmp37_ = g_new0 (void*, 1);
	params = _tmp37_;
	params_length1 = 1;
	_params_size_ = params_length1;
	_tmp38_ = params;
	_tmp38__length1 = params_length1;
	_tmp39_ = val;
	_tmp38_[0] = (void*) _tmp39_;
	_tmp40_ = _tmp38_[0];
	_tmp41_ = object;
	_tmp42_ = ctx;
	_tmp43_ = glob_object;
	_tmp44_ = params;
	_tmp44__length1 = params_length1;
	_tmp46_ = JSObjectCallAsFunction (_tmp42_, _tmp41_, _tmp43_, (size_t) ((_tmp44__length1 * sizeof (void*)) / sizeof (const struct OpaqueJSValue*)), (const struct OpaqueJSValue**) _tmp44_, &_tmp45_);
	_0 (exception);
	exception = _tmp45_;
	_result_ = _tmp46_;
	_tmp47_ = exception;
	if (_tmp47_ != NULL) {
		gchar* _tmp48_ = NULL;
		const struct OpaqueJSContext* _tmp49_;
		const struct OpaqueJSValue* _tmp50_;
		gchar* _tmp51_;
		GError* _tmp53_;
		_tmp49_ = ctx;
		_tmp50_ = exception;
		_tmp51_ = nuvola_js_tools_exception_to_string (_tmp49_, _tmp50_);
		_tmp48_ = _tmp51_;
		if (_tmp48_ == NULL) {
			gchar* _tmp52_;
			_tmp52_ = g_strdup ("(null)");
			_g_free0 (_tmp48_);
			_tmp48_ = _tmp52_;
		}
		_tmp53_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_WRONG_TYPE, "Unsupported type. %s", _tmp48_);
		_inner_error_ = _tmp53_;
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (_tmp48_);
			_0 (exception);
			params = (g_free (params), NULL);
			return NULL;
		} else {
			_g_free0 (_tmp48_);
			_0 (exception);
			params = (g_free (params), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_free0 (_tmp48_);
	}
	_tmp54_ = _result_;
	_tmp55_ = ctx;
	_tmp56_ = JSValueToBoolean (_tmp55_, _tmp54_);
	if (_tmp56_) {
		GVariantBuilder* builder = NULL;
		GVariantType* _tmp57_;
		GVariantType* _tmp58_;
		GVariantBuilder* _tmp59_;
		GVariantBuilder* _tmp60_;
		const struct OpaqueJSValue* _tmp61_;
		gint size = 0;
		const struct OpaqueJSContext* _tmp62_;
		struct OpaqueJSValue* _tmp63_;
		gdouble _tmp64_;
		GVariantBuilder* _tmp77_;
		GVariant* _tmp78_;
		_tmp57_ = g_variant_type_new ("av");
		_tmp58_ = _tmp57_;
		_tmp59_ = g_variant_builder_new (_tmp58_);
		_tmp60_ = _tmp59_;
		_g_variant_type_free0 (_tmp58_);
		builder = _tmp60_;
		_tmp61_ = val;
		object = (struct OpaqueJSValue*) _tmp61_;
		_tmp62_ = ctx;
		_tmp63_ = object;
		_tmp64_ = nuvola_js_tools_o_get_number (_tmp62_, _tmp63_, "length");
		size = (gint) _tmp64_;
		{
			guint i = 0U;
			i = (guint) 0;
			{
				gboolean _tmp65_ = FALSE;
				_tmp65_ = TRUE;
				while (TRUE) {
					guint _tmp67_;
					gint _tmp68_;
					GVariant* _tmp69_ = NULL;
					const struct OpaqueJSContext* _tmp70_;
					struct OpaqueJSValue* _tmp71_;
					const struct OpaqueJSContext* _tmp72_;
					guint _tmp73_;
					const struct OpaqueJSValue* _tmp74_;
					GVariant* _tmp75_;
					GVariantBuilder* _tmp76_;
					if (!_tmp65_) {
						guint _tmp66_;
						_tmp66_ = i;
						i = _tmp66_ + 1;
					}
					_tmp65_ = FALSE;
					_tmp67_ = i;
					_tmp68_ = size;
					if (!(_tmp67_ < ((guint) _tmp68_))) {
						break;
					}
					_tmp70_ = ctx;
					_tmp71_ = object;
					_tmp72_ = ctx;
					_tmp73_ = i;
					_tmp74_ = JSObjectGetPropertyAtIndex (_tmp72_, _tmp71_, _tmp73_, NULL);
					_tmp75_ = nuvola_js_tools_variant_from_value (_tmp70_, _tmp74_, &_inner_error_);
					_tmp69_ = _tmp75_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == NUVOLA_JS_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_variant_builder_unref0 (builder);
							_0 (exception);
							params = (g_free (params), NULL);
							return NULL;
						} else {
							_g_variant_builder_unref0 (builder);
							_0 (exception);
							params = (g_free (params), NULL);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
					_tmp76_ = builder;
					g_variant_builder_add (_tmp76_, "v", _tmp69_, NULL);
					_g_variant_unref0 (_tmp69_);
				}
			}
		}
		_tmp77_ = builder;
		_tmp78_ = g_variant_builder_end (_tmp77_);
		g_variant_ref_sink (_tmp78_);
		result = _tmp78_;
		_g_variant_builder_unref0 (builder);
		_0 (exception);
		params = (g_free (params), NULL);
		return result;
	}
	_tmp79_ = val;
	_tmp80_ = ctx;
	_tmp81_ = JSValueIsObject (_tmp80_, _tmp79_);
	if (_tmp81_) {
		const struct OpaqueJSValue* _tmp82_;
		struct OpaqueJSPropertyNameArray* properties = NULL;
		struct OpaqueJSValue* _tmp83_;
		const struct OpaqueJSContext* _tmp84_;
		struct OpaqueJSPropertyNameArray* _tmp85_;
		gsize size = 0UL;
		struct OpaqueJSPropertyNameArray* _tmp86_;
		gsize _tmp87_;
		GVariantBuilder* builder = NULL;
		GVariantType* _tmp88_;
		GVariantType* _tmp89_;
		GVariantBuilder* _tmp90_;
		GVariantBuilder* _tmp91_;
		GVariantBuilder* _tmp110_;
		GVariant* _tmp111_;
		_tmp82_ = val;
		object = (struct OpaqueJSValue*) _tmp82_;
		_tmp83_ = object;
		_tmp84_ = ctx;
		_tmp85_ = JSObjectCopyPropertyNames (_tmp84_, _tmp83_);
		properties = _tmp85_;
		_tmp86_ = properties;
		_tmp87_ = JSPropertyNameArrayGetCount (_tmp86_);
		size = _tmp87_;
		_tmp88_ = g_variant_type_new ("a{smv}");
		_tmp89_ = _tmp88_;
		_tmp90_ = g_variant_builder_new (_tmp89_);
		_tmp91_ = _tmp90_;
		_g_variant_type_free0 (_tmp89_);
		builder = _tmp91_;
		{
			gsize i = 0UL;
			i = (gsize) 0;
			{
				gboolean _tmp92_ = FALSE;
				_tmp92_ = TRUE;
				while (TRUE) {
					gsize _tmp94_;
					gsize _tmp95_;
					struct OpaqueJSString* js_property = NULL;
					struct OpaqueJSPropertyNameArray* _tmp96_;
					gsize _tmp97_;
					struct OpaqueJSString* _tmp98_;
					GVariant* value = NULL;
					const struct OpaqueJSContext* _tmp99_;
					struct OpaqueJSValue* _tmp100_;
					const struct OpaqueJSContext* _tmp101_;
					struct OpaqueJSString* _tmp102_;
					const struct OpaqueJSValue* _tmp103_;
					GVariant* _tmp104_;
					GVariantBuilder* _tmp105_;
					struct OpaqueJSString* _tmp106_;
					gchar* _tmp107_;
					gchar* _tmp108_;
					GVariant* _tmp109_;
					if (!_tmp92_) {
						gsize _tmp93_;
						_tmp93_ = i;
						i = _tmp93_ + 1;
					}
					_tmp92_ = FALSE;
					_tmp94_ = i;
					_tmp95_ = size;
					if (!(_tmp94_ < _tmp95_)) {
						break;
					}
					_tmp96_ = properties;
					_tmp97_ = i;
					_tmp98_ = JSPropertyNameArrayGetNameAtIndex (_tmp96_, _tmp97_);
					js_property = _tmp98_;
					_tmp99_ = ctx;
					_tmp100_ = object;
					_tmp101_ = ctx;
					_tmp102_ = js_property;
					_tmp103_ = JSObjectGetProperty (_tmp101_, _tmp100_, _tmp102_, NULL);
					_tmp104_ = nuvola_js_tools_variant_from_value (_tmp99_, _tmp103_, &_inner_error_);
					value = _tmp104_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == NUVOLA_JS_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_variant_builder_unref0 (builder);
							_JSPropertyNameArrayRelease0 (properties);
							_0 (exception);
							params = (g_free (params), NULL);
							return NULL;
						} else {
							_g_variant_builder_unref0 (builder);
							_JSPropertyNameArrayRelease0 (properties);
							_0 (exception);
							params = (g_free (params), NULL);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
					_tmp105_ = builder;
					_tmp106_ = js_property;
					_tmp107_ = nuvola_js_tools_utf8_string (_tmp106_);
					_tmp108_ = _tmp107_;
					_tmp109_ = value;
					g_variant_builder_add (_tmp105_, "{smv}", _tmp108_, _tmp109_, NULL);
					_g_free0 (_tmp108_);
					_g_variant_unref0 (value);
				}
			}
		}
		_tmp110_ = builder;
		_tmp111_ = g_variant_builder_end (_tmp110_);
		g_variant_ref_sink (_tmp111_);
		result = _tmp111_;
		_g_variant_builder_unref0 (builder);
		_JSPropertyNameArrayRelease0 (properties);
		_0 (exception);
		params = (g_free (params), NULL);
		return result;
	}
	g_warning ("jstools.vala:381: Attempt to convert `undefined` JavaScript type. This" \
" might be a programmer error!");
	_tmp112_ = g_variant_new_string ("<ERROR: UNDEFINED VALUE TYPE>");
	g_variant_ref_sink (_tmp112_);
	result = _tmp112_;
	_0 (exception);
	params = (g_free (params), NULL);
	return result;
}



