/* GlobalKeyBindings.c generated by valac 0.38.1, the Vala compiler
 * generated from GlobalKeyBindings.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <dioritegtk4.h>


#define NUVOLA_TYPE_GLOBAL_KEYBINDINGS (nuvola_global_keybindings_get_type ())
#define NUVOLA_GLOBAL_KEYBINDINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_GLOBAL_KEYBINDINGS, NuvolaGlobalKeybindings))
#define NUVOLA_GLOBAL_KEYBINDINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_GLOBAL_KEYBINDINGS, NuvolaGlobalKeybindingsClass))
#define NUVOLA_IS_GLOBAL_KEYBINDINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_GLOBAL_KEYBINDINGS))
#define NUVOLA_IS_GLOBAL_KEYBINDINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_GLOBAL_KEYBINDINGS))
#define NUVOLA_GLOBAL_KEYBINDINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_GLOBAL_KEYBINDINGS, NuvolaGlobalKeybindingsClass))

typedef struct _NuvolaGlobalKeybindings NuvolaGlobalKeybindings;
typedef struct _NuvolaGlobalKeybindingsClass NuvolaGlobalKeybindingsClass;
typedef struct _NuvolaGlobalKeybindingsPrivate NuvolaGlobalKeybindingsPrivate;

#define NUVOLA_TYPE_ACTIONS_KEY_BINDER (nuvola_actions_key_binder_get_type ())
#define NUVOLA_ACTIONS_KEY_BINDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_ACTIONS_KEY_BINDER, NuvolaActionsKeyBinder))
#define NUVOLA_IS_ACTIONS_KEY_BINDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_ACTIONS_KEY_BINDER))
#define NUVOLA_ACTIONS_KEY_BINDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_ACTIONS_KEY_BINDER, NuvolaActionsKeyBinderIface))

typedef struct _NuvolaActionsKeyBinder NuvolaActionsKeyBinder;
typedef struct _NuvolaActionsKeyBinderIface NuvolaActionsKeyBinderIface;
enum  {
	NUVOLA_GLOBAL_KEYBINDINGS_DUMMY_PROPERTY,
	NUVOLA_GLOBAL_KEYBINDINGS_KEYBINDER_PROPERTY,
	NUVOLA_GLOBAL_KEYBINDINGS_LAST_PROPERTY
};
static GParamSpec* nuvola_global_keybindings_properties[NUVOLA_GLOBAL_KEYBINDINGS_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

struct _NuvolaGlobalKeybindings {
	GObject parent_instance;
	NuvolaGlobalKeybindingsPrivate * priv;
};

struct _NuvolaGlobalKeybindingsClass {
	GObjectClass parent_class;
};

struct _NuvolaActionsKeyBinderIface {
	GTypeInterface parent_iface;
	gchar* (*get_keybinding) (NuvolaActionsKeyBinder* self, const gchar* name);
	gboolean (*set_keybinding) (NuvolaActionsKeyBinder* self, const gchar* name, const gchar* keybinding);
	gboolean (*bind) (NuvolaActionsKeyBinder* self, const gchar* name);
	gboolean (*unbind) (NuvolaActionsKeyBinder* self, const gchar* name);
	gboolean (*is_available) (NuvolaActionsKeyBinder* self, const gchar* keybinding);
	gchar* (*get_action) (NuvolaActionsKeyBinder* self, const gchar* keybinding);
};

struct _NuvolaGlobalKeybindingsPrivate {
	NuvolaActionsKeyBinder* _keybinder;
	DrtgtkActions* actions;
};


static gpointer nuvola_global_keybindings_parent_class = NULL;

GType nuvola_global_keybindings_get_type (void) G_GNUC_CONST;
GType nuvola_actions_key_binder_get_type (void) G_GNUC_CONST;
#define NUVOLA_GLOBAL_KEYBINDINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_GLOBAL_KEYBINDINGS, NuvolaGlobalKeybindingsPrivate))
NuvolaGlobalKeybindings* nuvola_global_keybindings_new (NuvolaActionsKeyBinder* keybinder, DrtgtkActions* actions);
NuvolaGlobalKeybindings* nuvola_global_keybindings_construct (GType object_type, NuvolaActionsKeyBinder* keybinder, DrtgtkActions* actions);
static void nuvola_global_keybindings_set_keybinder (NuvolaGlobalKeybindings* self, NuvolaActionsKeyBinder* value);
static void nuvola_global_keybindings_on_action_activated (NuvolaGlobalKeybindings* self, const gchar* name, gboolean* handled);
static void _nuvola_global_keybindings_on_action_activated_nuvola_actions_key_binder_action_activated (NuvolaActionsKeyBinder* _sender, const gchar* action, gboolean* handled, gpointer self);
static void nuvola_global_keybindings_update_action (NuvolaGlobalKeybindings* self, DrtgtkAction* action);
static void _nuvola_global_keybindings_update_action_drtgtk_actions_action_added (DrtgtkActions* _sender, DrtgtkAction* action, gpointer self);
static void nuvola_global_keybindings_on_action_removed (NuvolaGlobalKeybindings* self, DrtgtkAction* action);
static void _nuvola_global_keybindings_on_action_removed_drtgtk_actions_action_removed (DrtgtkActions* _sender, DrtgtkAction* action, gpointer self);
NuvolaActionsKeyBinder* nuvola_global_keybindings_get_keybinder (NuvolaGlobalKeybindings* self);
gboolean nuvola_actions_key_binder_bind (NuvolaActionsKeyBinder* self, const gchar* name);
gboolean nuvola_actions_key_binder_unbind (NuvolaActionsKeyBinder* self, const gchar* name);
static void nuvola_global_keybindings_finalize (GObject * obj);
static void _vala_nuvola_global_keybindings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_global_keybindings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _nuvola_global_keybindings_on_action_activated_nuvola_actions_key_binder_action_activated (NuvolaActionsKeyBinder* _sender, const gchar* action, gboolean* handled, gpointer self) {
	nuvola_global_keybindings_on_action_activated ((NuvolaGlobalKeybindings*) self, action, handled);
}


static void _nuvola_global_keybindings_update_action_drtgtk_actions_action_added (DrtgtkActions* _sender, DrtgtkAction* action, gpointer self) {
	nuvola_global_keybindings_update_action ((NuvolaGlobalKeybindings*) self, action);
}


static void _nuvola_global_keybindings_on_action_removed_drtgtk_actions_action_removed (DrtgtkActions* _sender, DrtgtkAction* action, gpointer self) {
	nuvola_global_keybindings_on_action_removed ((NuvolaGlobalKeybindings*) self, action);
}


NuvolaGlobalKeybindings* nuvola_global_keybindings_construct (GType object_type, NuvolaActionsKeyBinder* keybinder, DrtgtkActions* actions) {
	NuvolaGlobalKeybindings * self = NULL;
	NuvolaActionsKeyBinder* _tmp0_;
	DrtgtkActions* _tmp1_;
	DrtgtkActions* _tmp2_;
	NuvolaActionsKeyBinder* _tmp3_;
	DrtgtkActions* _tmp4_;
	DrtgtkActions* _tmp5_;
	DrtgtkActions* _tmp6_;
	GList* _tmp7_;
	g_return_val_if_fail (keybinder != NULL, NULL);
	g_return_val_if_fail (actions != NULL, NULL);
	self = (NuvolaGlobalKeybindings*) g_object_new (object_type, NULL);
	_tmp0_ = keybinder;
	nuvola_global_keybindings_set_keybinder (self, _tmp0_);
	_tmp1_ = actions;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (self->priv->actions);
	self->priv->actions = _tmp2_;
	_tmp3_ = keybinder;
	g_signal_connect_object (_tmp3_, "action-activated", (GCallback) _nuvola_global_keybindings_on_action_activated_nuvola_actions_key_binder_action_activated, self, 0);
	_tmp4_ = actions;
	g_signal_connect_object (_tmp4_, "action-added", (GCallback) _nuvola_global_keybindings_update_action_drtgtk_actions_action_added, self, 0);
	_tmp5_ = actions;
	g_signal_connect_object (_tmp5_, "action-removed", (GCallback) _nuvola_global_keybindings_on_action_removed_drtgtk_actions_action_removed, self, 0);
	_tmp6_ = actions;
	_tmp7_ = drtgtk_actions_list_actions (_tmp6_);
	{
		GList* action_collection = NULL;
		GList* action_it = NULL;
		action_collection = _tmp7_;
		for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
			DrtgtkAction* action = NULL;
			action = (DrtgtkAction*) action_it->data;
			{
				DrtgtkAction* _tmp8_;
				_tmp8_ = action;
				nuvola_global_keybindings_update_action (self, _tmp8_);
			}
		}
		_g_list_free0 (action_collection);
	}
	return self;
}


NuvolaGlobalKeybindings* nuvola_global_keybindings_new (NuvolaActionsKeyBinder* keybinder, DrtgtkActions* actions) {
	return nuvola_global_keybindings_construct (NUVOLA_TYPE_GLOBAL_KEYBINDINGS, keybinder, actions);
}


static void nuvola_global_keybindings_update_action (NuvolaGlobalKeybindings* self, DrtgtkAction* action) {
	DrtgtkAction* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = action;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, DRTGTK_TYPE_RADIO_ACTION)) {
		NuvolaActionsKeyBinder* _tmp1_;
		DrtgtkAction* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp1_ = self->priv->_keybinder;
		_tmp2_ = action;
		_tmp3_ = drtgtk_action_get_name (_tmp2_);
		_tmp4_ = _tmp3_;
		nuvola_actions_key_binder_bind (_tmp1_, _tmp4_);
	}
}


static void nuvola_global_keybindings_on_action_removed (NuvolaGlobalKeybindings* self, DrtgtkAction* action) {
	DrtgtkAction* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = action;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, DRTGTK_TYPE_RADIO_ACTION)) {
		NuvolaActionsKeyBinder* _tmp1_;
		DrtgtkAction* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp1_ = self->priv->_keybinder;
		_tmp2_ = action;
		_tmp3_ = drtgtk_action_get_name (_tmp2_);
		_tmp4_ = _tmp3_;
		nuvola_actions_key_binder_unbind (_tmp1_, _tmp4_);
	}
}


static void nuvola_global_keybindings_on_action_activated (NuvolaGlobalKeybindings* self, const gchar* name, gboolean* handled) {
	gboolean _tmp0_;
	DrtgtkAction* action = NULL;
	DrtgtkActions* _tmp1_;
	const gchar* _tmp2_;
	DrtgtkAction* _tmp3_;
	DrtgtkAction* _tmp4_;
	DrtgtkAction* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = *handled;
	if (_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->actions;
	_tmp2_ = name;
	_tmp3_ = drtgtk_actions_get_action (_tmp1_, _tmp2_);
	action = _tmp3_;
	_tmp4_ = action;
	g_return_if_fail (_tmp4_ != NULL);
	_tmp5_ = action;
	drtgtk_action_activate (_tmp5_, NULL);
	*handled = TRUE;
	_g_object_unref0 (action);
}


NuvolaActionsKeyBinder* nuvola_global_keybindings_get_keybinder (NuvolaGlobalKeybindings* self) {
	NuvolaActionsKeyBinder* result;
	NuvolaActionsKeyBinder* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_keybinder;
	result = _tmp0_;
	return result;
}


static void nuvola_global_keybindings_set_keybinder (NuvolaGlobalKeybindings* self, NuvolaActionsKeyBinder* value) {
	g_return_if_fail (self != NULL);
	if (nuvola_global_keybindings_get_keybinder (self) != value) {
		NuvolaActionsKeyBinder* _tmp0_;
		NuvolaActionsKeyBinder* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_keybinder);
		self->priv->_keybinder = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, nuvola_global_keybindings_properties[NUVOLA_GLOBAL_KEYBINDINGS_KEYBINDER_PROPERTY]);
	}
}


static void nuvola_global_keybindings_class_init (NuvolaGlobalKeybindingsClass * klass) {
	nuvola_global_keybindings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaGlobalKeybindingsPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_global_keybindings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_global_keybindings_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_global_keybindings_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_GLOBAL_KEYBINDINGS_KEYBINDER_PROPERTY, nuvola_global_keybindings_properties[NUVOLA_GLOBAL_KEYBINDINGS_KEYBINDER_PROPERTY] = g_param_spec_object ("keybinder", "keybinder", "keybinder", NUVOLA_TYPE_ACTIONS_KEY_BINDER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void nuvola_global_keybindings_instance_init (NuvolaGlobalKeybindings * self) {
	self->priv = NUVOLA_GLOBAL_KEYBINDINGS_GET_PRIVATE (self);
}


static void nuvola_global_keybindings_finalize (GObject * obj) {
	NuvolaGlobalKeybindings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_GLOBAL_KEYBINDINGS, NuvolaGlobalKeybindings);
	_g_object_unref0 (self->priv->_keybinder);
	_g_object_unref0 (self->priv->actions);
	G_OBJECT_CLASS (nuvola_global_keybindings_parent_class)->finalize (obj);
}


GType nuvola_global_keybindings_get_type (void) {
	static volatile gsize nuvola_global_keybindings_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_global_keybindings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaGlobalKeybindingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_global_keybindings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaGlobalKeybindings), 0, (GInstanceInitFunc) nuvola_global_keybindings_instance_init, NULL };
		GType nuvola_global_keybindings_type_id;
		nuvola_global_keybindings_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaGlobalKeybindings", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_global_keybindings_type_id__volatile, nuvola_global_keybindings_type_id);
	}
	return nuvola_global_keybindings_type_id__volatile;
}


static void _vala_nuvola_global_keybindings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaGlobalKeybindings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_GLOBAL_KEYBINDINGS, NuvolaGlobalKeybindings);
	switch (property_id) {
		case NUVOLA_GLOBAL_KEYBINDINGS_KEYBINDER_PROPERTY:
		g_value_set_object (value, nuvola_global_keybindings_get_keybinder (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_global_keybindings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaGlobalKeybindings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_GLOBAL_KEYBINDINGS, NuvolaGlobalKeybindings);
	switch (property_id) {
		case NUVOLA_GLOBAL_KEYBINDINGS_KEYBINDER_PROPERTY:
		nuvola_global_keybindings_set_keybinder (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



