/* KeybindingsSettings.c generated by valac 0.38.1, the Vala compiler
 * generated from KeybindingsSettings.vala, do not modify */

/*
 * Copyright 2014-2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <dioritegtk4.h>
#include <nuvolaruntime-base.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <dioriteglib4.h>


#define NUVOLA_TYPE_KEYBINDINGS_SETTINGS (nuvola_keybindings_settings_get_type ())
#define NUVOLA_KEYBINDINGS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_KEYBINDINGS_SETTINGS, NuvolaKeybindingsSettings))
#define NUVOLA_KEYBINDINGS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_KEYBINDINGS_SETTINGS, NuvolaKeybindingsSettingsClass))
#define NUVOLA_IS_KEYBINDINGS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_KEYBINDINGS_SETTINGS))
#define NUVOLA_IS_KEYBINDINGS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_KEYBINDINGS_SETTINGS))
#define NUVOLA_KEYBINDINGS_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_KEYBINDINGS_SETTINGS, NuvolaKeybindingsSettingsClass))

typedef struct _NuvolaKeybindingsSettings NuvolaKeybindingsSettings;
typedef struct _NuvolaKeybindingsSettingsClass NuvolaKeybindingsSettingsClass;
typedef struct _NuvolaKeybindingsSettingsPrivate NuvolaKeybindingsSettingsPrivate;

#define NUVOLA_TYPE_ACTIONS_KEY_BINDER (nuvola_actions_key_binder_get_type ())
#define NUVOLA_ACTIONS_KEY_BINDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_ACTIONS_KEY_BINDER, NuvolaActionsKeyBinder))
#define NUVOLA_IS_ACTIONS_KEY_BINDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_ACTIONS_KEY_BINDER))
#define NUVOLA_ACTIONS_KEY_BINDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_ACTIONS_KEY_BINDER, NuvolaActionsKeyBinderIface))

typedef struct _NuvolaActionsKeyBinder NuvolaActionsKeyBinder;
typedef struct _NuvolaActionsKeyBinderIface NuvolaActionsKeyBinderIface;
enum  {
	NUVOLA_KEYBINDINGS_SETTINGS_DUMMY_PROPERTY,
	NUVOLA_KEYBINDINGS_SETTINGS_LAST_PROPERTY
};
static GParamSpec* nuvola_keybindings_settings_properties[NUVOLA_KEYBINDINGS_SETTINGS_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL)))

struct _NuvolaKeybindingsSettings {
	GtkGrid parent_instance;
	NuvolaKeybindingsSettingsPrivate * priv;
};

struct _NuvolaKeybindingsSettingsClass {
	GtkGridClass parent_class;
};

struct _NuvolaActionsKeyBinderIface {
	GTypeInterface parent_iface;
	gchar* (*get_keybinding) (NuvolaActionsKeyBinder* self, const gchar* name);
	gboolean (*set_keybinding) (NuvolaActionsKeyBinder* self, const gchar* name, const gchar* keybinding);
	gboolean (*bind) (NuvolaActionsKeyBinder* self, const gchar* name);
	gboolean (*unbind) (NuvolaActionsKeyBinder* self, const gchar* name);
	gboolean (*is_available) (NuvolaActionsKeyBinder* self, const gchar* keybinding);
	gchar* (*get_action) (NuvolaActionsKeyBinder* self, const gchar* keybinding);
};

struct _NuvolaKeybindingsSettingsPrivate {
	DrtgtkActions* actions_reg;
	NuvolaConfig* config;
	NuvolaActionsKeyBinder* global_keybindings;
	GtkTreeView* view;
	GtkListStore* model;
	GtkInfoBar* info_bar;
	GtkLabel* error_label;
};


static gpointer nuvola_keybindings_settings_parent_class = NULL;

GType nuvola_keybindings_settings_get_type (void) G_GNUC_CONST;
GType nuvola_actions_key_binder_get_type (void) G_GNUC_CONST;
#define NUVOLA_KEYBINDINGS_SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_KEYBINDINGS_SETTINGS, NuvolaKeybindingsSettingsPrivate))
NuvolaKeybindingsSettings* nuvola_keybindings_settings_new (DrtgtkActions* actions_reg, NuvolaConfig* config, NuvolaActionsKeyBinder* global_keybindings);
NuvolaKeybindingsSettings* nuvola_keybindings_settings_construct (GType object_type, DrtgtkActions* actions_reg, NuvolaConfig* config, NuvolaActionsKeyBinder* global_keybindings);
gchar* nuvola_actions_key_binder_get_keybinding (NuvolaActionsKeyBinder* self, const gchar* name);
static void nuvola_keybindings_settings_on_accel_edited (NuvolaKeybindingsSettings* self, const gchar* path_string, guint accel_key, GdkModifierType accel_mods, guint hardware_keycode);
static void _nuvola_keybindings_settings_on_accel_edited_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender, const gchar* path_string, guint accel_key, GdkModifierType accel_mods, guint hardware_keycode, gpointer self);
static void nuvola_keybindings_settings_on_accel_cleared (NuvolaKeybindingsSettings* self, const gchar* path_string);
static void _nuvola_keybindings_settings_on_accel_cleared_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender, const gchar* path_string, gpointer self);
static void nuvola_keybindings_settings_on_glob_accel_edited (NuvolaKeybindingsSettings* self, const gchar* path_string, guint accel_key, GdkModifierType accel_mods, guint hardware_keycode);
static void _nuvola_keybindings_settings_on_glob_accel_edited_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender, const gchar* path_string, guint accel_key, GdkModifierType accel_mods, guint hardware_keycode, gpointer self);
static void nuvola_keybindings_settings_on_glob_accel_cleared (NuvolaKeybindingsSettings* self, const gchar* path_string);
static void _nuvola_keybindings_settings_on_glob_accel_cleared_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender, const gchar* path_string, gpointer self);
gboolean nuvola_actions_key_binder_set_keybinding (NuvolaActionsKeyBinder* self, const gchar* name, const gchar* keybinding);
static void nuvola_keybindings_settings_set_error (NuvolaKeybindingsSettings* self, const gchar* _error_);
static void nuvola_keybindings_settings_finalize (GObject * obj);


/**
 * Constructs new main window
 * 
 * @param app Application object
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _nuvola_keybindings_settings_on_accel_edited_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender, const gchar* path_string, guint accel_key, GdkModifierType accel_mods, guint hardware_keycode, gpointer self) {
	nuvola_keybindings_settings_on_accel_edited ((NuvolaKeybindingsSettings*) self, path_string, accel_key, accel_mods, hardware_keycode);
}


static void _nuvola_keybindings_settings_on_accel_cleared_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender, const gchar* path_string, gpointer self) {
	nuvola_keybindings_settings_on_accel_cleared ((NuvolaKeybindingsSettings*) self, path_string);
}


static void _nuvola_keybindings_settings_on_glob_accel_edited_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender, const gchar* path_string, guint accel_key, GdkModifierType accel_mods, guint hardware_keycode, gpointer self) {
	nuvola_keybindings_settings_on_glob_accel_edited ((NuvolaKeybindingsSettings*) self, path_string, accel_key, accel_mods, hardware_keycode);
}


static void _nuvola_keybindings_settings_on_glob_accel_cleared_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender, const gchar* path_string, gpointer self) {
	nuvola_keybindings_settings_on_glob_accel_cleared ((NuvolaKeybindingsSettings*) self, path_string);
}


NuvolaKeybindingsSettings* nuvola_keybindings_settings_construct (GType object_type, DrtgtkActions* actions_reg, NuvolaConfig* config, NuvolaActionsKeyBinder* global_keybindings) {
	NuvolaKeybindingsSettings * self = NULL;
	DrtgtkActions* _tmp0_;
	DrtgtkActions* _tmp1_;
	NuvolaConfig* _tmp2_;
	NuvolaConfig* _tmp3_;
	NuvolaActionsKeyBinder* _tmp4_;
	NuvolaActionsKeyBinder* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkInfoBar* _tmp10_;
	GtkInfoBar* _tmp11_;
	GtkInfoBar* _tmp12_;
	GtkContainer* _tmp13_;
	GtkLabel* _tmp14_;
	GtkInfoBar* _tmp15_;
	GtkInfoBar* _tmp16_;
	gchar* info_text = NULL;
	gchar* _tmp17_;
	GtkLabel* info_label = NULL;
	const gchar* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp24_;
	GtkScrolledWindow* _tmp25_;
	GtkScrolledWindow* _tmp26_;
	GtkListStore* _tmp27_;
	GtkTreeIter iter = {0};
	DrtgtkActions* _tmp28_;
	GList* _tmp29_;
	GtkListStore* _tmp66_;
	GtkTreeView* _tmp67_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp68_;
	GtkTreeView* _tmp69_;
	GtkCellRendererAccel* accel_cell = NULL;
	GtkCellRendererAccel* _tmp70_;
	GtkCellRendererAccel* _tmp71_;
	GtkCellRendererAccel* _tmp72_;
	GtkCellRendererAccel* _tmp73_;
	GtkCellRendererAccel* _tmp74_;
	GtkTreeView* _tmp75_;
	GtkCellRendererAccel* _tmp76_;
	GtkCellRendererAccel* _tmp77_;
	GtkCellRendererAccel* _tmp78_;
	GtkCellRendererAccel* _tmp79_;
	GtkCellRendererAccel* _tmp80_;
	GtkCellRendererAccel* _tmp81_;
	GtkTreeView* _tmp82_;
	GtkCellRendererAccel* _tmp83_;
	GtkScrolledWindow* _tmp84_;
	GtkScrolledWindow* _tmp85_;
	GtkScrolledWindow* _tmp86_;
	GtkTreeView* _tmp87_;
	GtkTreeView* _tmp88_;
	g_return_val_if_fail (actions_reg != NULL, NULL);
	g_return_val_if_fail (config != NULL, NULL);
	g_return_val_if_fail (global_keybindings != NULL, NULL);
	self = (NuvolaKeybindingsSettings*) g_object_new (object_type, NULL);
	_tmp0_ = actions_reg;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->actions_reg);
	self->priv->actions_reg = _tmp1_;
	_tmp2_ = config;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->config);
	self->priv->config = _tmp3_;
	_tmp4_ = global_keybindings;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 (self->priv->global_keybindings);
	self->priv->global_keybindings = _tmp5_;
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 5);
	g_object_set ((GtkWidget*) self, "margin", 1, NULL);
	_tmp6_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->error_label);
	self->priv->error_label = _tmp6_;
	_tmp7_ = self->priv->error_label;
	gtk_label_set_line_wrap (_tmp7_, TRUE);
	_tmp8_ = self->priv->error_label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp8_, TRUE);
	_tmp9_ = self->priv->error_label;
	gtk_widget_show ((GtkWidget*) _tmp9_);
	_tmp10_ = (GtkInfoBar*) gtk_info_bar_new ();
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->info_bar);
	self->priv->info_bar = _tmp10_;
	_tmp11_ = self->priv->info_bar;
	gtk_info_bar_set_message_type (_tmp11_, GTK_MESSAGE_INFO);
	_tmp12_ = self->priv->info_bar;
	_tmp13_ = gtk_info_bar_get_content_area (_tmp12_);
	_tmp14_ = self->priv->error_label;
	gtk_container_add (_tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = self->priv->info_bar;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp15_, TRUE);
	_tmp16_ = self->priv->info_bar;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp16_, 0, 0, 1, 1);
	_tmp17_ = g_strdup ("Double click a keyboard shortcut and then press a new one to change it" \
" or the backspace key to delete it.");
	info_text = _tmp17_;
	_tmp18_ = info_text;
	_tmp19_ = (GtkLabel*) gtk_label_new (_tmp18_);
	g_object_ref_sink (_tmp19_);
	info_label = _tmp19_;
	_tmp20_ = info_label;
	g_object_set ((GtkWidget*) _tmp20_, "margin", 10, NULL);
	_tmp21_ = info_label;
	g_object_set (_tmp21_, "wrap", TRUE, NULL);
	_tmp22_ = info_label;
	gtk_widget_show ((GtkWidget*) _tmp22_);
	_tmp23_ = info_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp23_, 0, 1, 1, 1);
	_tmp24_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp24_);
	scroll = _tmp24_;
	_tmp25_ = scroll;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp25_, 0, 2, 1, 1);
	_tmp26_ = scroll;
	gtk_widget_show_all ((GtkWidget*) _tmp26_);
	_tmp27_ = gtk_list_store_new (6, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_UINT, gdk_modifier_type_get_type (), G_TYPE_UINT, gdk_modifier_type_get_type (), -1);
	_g_object_unref0 (self->priv->model);
	self->priv->model = _tmp27_;
	_tmp28_ = actions_reg;
	_tmp29_ = drtgtk_actions_list_actions (_tmp28_);
	{
		GList* action_collection = NULL;
		GList* action_it = NULL;
		action_collection = _tmp29_;
		for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
			DrtgtkAction* action = NULL;
			action = (DrtgtkAction*) action_it->data;
			{
				gchar* label = NULL;
				DrtgtkAction* _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				gchar* _tmp33_;
				gboolean _tmp34_ = FALSE;
				DrtgtkAction* _tmp35_;
				gchar* keybinding = NULL;
				DrtgtkAction* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				gchar* _tmp40_;
				guint accel_key = 0U;
				GdkModifierType accel_mods = 0;
				const gchar* _tmp41_;
				NuvolaActionsKeyBinder* _tmp45_;
				DrtgtkAction* _tmp46_;
				const gchar* _tmp47_;
				const gchar* _tmp48_;
				gchar* _tmp49_;
				guint glob_accel_key = 0U;
				GdkModifierType glob_accel_mods = 0;
				const gchar* _tmp50_;
				GtkListStore* _tmp54_;
				GtkTreeIter _tmp55_ = {0};
				GtkListStore* _tmp56_;
				GtkTreeIter _tmp57_;
				DrtgtkAction* _tmp58_;
				const gchar* _tmp59_;
				const gchar* _tmp60_;
				const gchar* _tmp61_;
				guint _tmp62_;
				GdkModifierType _tmp63_;
				guint _tmp64_;
				GdkModifierType _tmp65_;
				_tmp30_ = action;
				_tmp31_ = drtgtk_action_get_label (_tmp30_);
				_tmp32_ = _tmp31_;
				_tmp33_ = g_strdup (_tmp32_);
				label = _tmp33_;
				_tmp35_ = action;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp35_, DRTGTK_TYPE_RADIO_ACTION)) {
					_tmp34_ = TRUE;
				} else {
					const gchar* _tmp36_;
					_tmp36_ = label;
					_tmp34_ = _tmp36_ == NULL;
				}
				if (_tmp34_) {
					_g_free0 (label);
					continue;
				}
				_tmp37_ = action;
				_tmp38_ = drtgtk_action_get_keybinding (_tmp37_);
				_tmp39_ = _tmp38_;
				_tmp40_ = g_strdup (_tmp39_);
				keybinding = _tmp40_;
				_tmp41_ = keybinding;
				if (_tmp41_ != NULL) {
					const gchar* _tmp42_;
					guint _tmp43_ = 0U;
					GdkModifierType _tmp44_ = 0;
					_tmp42_ = keybinding;
					gtk_accelerator_parse (_tmp42_, &_tmp43_, &_tmp44_);
					accel_key = _tmp43_;
					accel_mods = _tmp44_;
				} else {
					accel_key = (guint) 0;
					accel_mods = 0;
				}
				_tmp45_ = global_keybindings;
				_tmp46_ = action;
				_tmp47_ = drtgtk_action_get_name (_tmp46_);
				_tmp48_ = _tmp47_;
				_tmp49_ = nuvola_actions_key_binder_get_keybinding (_tmp45_, _tmp48_);
				_g_free0 (keybinding);
				keybinding = _tmp49_;
				_tmp50_ = keybinding;
				if (_tmp50_ != NULL) {
					const gchar* _tmp51_;
					guint _tmp52_ = 0U;
					GdkModifierType _tmp53_ = 0;
					_tmp51_ = keybinding;
					gtk_accelerator_parse (_tmp51_, &_tmp52_, &_tmp53_);
					glob_accel_key = _tmp52_;
					glob_accel_mods = _tmp53_;
				} else {
					glob_accel_key = (guint) 0;
					glob_accel_mods = 0;
				}
				_tmp54_ = self->priv->model;
				gtk_list_store_append (_tmp54_, &_tmp55_);
				iter = _tmp55_;
				_tmp56_ = self->priv->model;
				_tmp57_ = iter;
				_tmp58_ = action;
				_tmp59_ = drtgtk_action_get_name (_tmp58_);
				_tmp60_ = _tmp59_;
				_tmp61_ = label;
				_tmp62_ = accel_key;
				_tmp63_ = accel_mods;
				_tmp64_ = glob_accel_key;
				_tmp65_ = glob_accel_mods;
				gtk_list_store_set (_tmp56_, &_tmp57_, 0, _tmp60_, 1, _tmp61_, 2, _tmp62_, 3, _tmp63_, 4, _tmp64_, 5, _tmp65_, -1, -1);
				_g_free0 (keybinding);
				_g_free0 (label);
			}
		}
		_g_list_free0 (action_collection);
	}
	_tmp66_ = self->priv->model;
	_tmp67_ = (GtkTreeView*) gtk_tree_view_new_with_model ((GtkTreeModel*) _tmp66_);
	g_object_ref_sink (_tmp67_);
	_g_object_unref0 (self->priv->view);
	self->priv->view = _tmp67_;
	_tmp68_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp68_);
	cell = _tmp68_;
	_tmp69_ = self->priv->view;
	gtk_tree_view_insert_column_with_attributes (_tmp69_, -1, "Action", (GtkCellRenderer*) cell, "text", 1, NULL);
	_tmp70_ = (GtkCellRendererAccel*) gtk_cell_renderer_accel_new ();
	g_object_ref_sink (_tmp70_);
	accel_cell = _tmp70_;
	_tmp71_ = accel_cell;
	g_object_set ((GtkCellRendererText*) _tmp71_, "editable", TRUE, NULL);
	_tmp72_ = accel_cell;
	g_object_set (_tmp72_, "accel-mode", GTK_CELL_RENDERER_ACCEL_MODE_GTK, NULL);
	_tmp73_ = accel_cell;
	g_signal_connect_object (_tmp73_, "accel-edited", (GCallback) _nuvola_keybindings_settings_on_accel_edited_gtk_cell_renderer_accel_accel_edited, self, 0);
	_tmp74_ = accel_cell;
	g_signal_connect_object (_tmp74_, "accel-cleared", (GCallback) _nuvola_keybindings_settings_on_accel_cleared_gtk_cell_renderer_accel_accel_cleared, self, 0);
	_tmp75_ = self->priv->view;
	_tmp76_ = accel_cell;
	gtk_tree_view_insert_column_with_attributes (_tmp75_, -1, "Shortcut", (GtkCellRenderer*) _tmp76_, "accel-key", 2, "accel-mods", 3, NULL);
	_tmp77_ = (GtkCellRendererAccel*) gtk_cell_renderer_accel_new ();
	g_object_ref_sink (_tmp77_);
	_g_object_unref0 (accel_cell);
	accel_cell = _tmp77_;
	_tmp78_ = accel_cell;
	g_object_set ((GtkCellRendererText*) _tmp78_, "editable", TRUE, NULL);
	_tmp79_ = accel_cell;
	g_object_set (_tmp79_, "accel-mode", GTK_CELL_RENDERER_ACCEL_MODE_GTK, NULL);
	_tmp80_ = accel_cell;
	g_signal_connect_object (_tmp80_, "accel-edited", (GCallback) _nuvola_keybindings_settings_on_glob_accel_edited_gtk_cell_renderer_accel_accel_edited, self, 0);
	_tmp81_ = accel_cell;
	g_signal_connect_object (_tmp81_, "accel-cleared", (GCallback) _nuvola_keybindings_settings_on_glob_accel_cleared_gtk_cell_renderer_accel_accel_cleared, self, 0);
	_tmp82_ = self->priv->view;
	_tmp83_ = accel_cell;
	gtk_tree_view_insert_column_with_attributes (_tmp82_, -1, "Global Shortcut", (GtkCellRenderer*) _tmp83_, "accel-key", 4, "accel-mods", 5, NULL);
	_tmp84_ = scroll;
	_tmp85_ = scroll;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp85_, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp84_, TRUE);
	_tmp86_ = scroll;
	_tmp87_ = self->priv->view;
	gtk_container_add ((GtkContainer*) _tmp86_, (GtkWidget*) _tmp87_);
	gtk_widget_show ((GtkWidget*) self);
	_tmp88_ = self->priv->view;
	gtk_widget_show ((GtkWidget*) _tmp88_);
	_g_object_unref0 (accel_cell);
	_g_object_unref0 (cell);
	_g_object_unref0 (scroll);
	_g_object_unref0 (info_label);
	_g_free0 (info_text);
	return self;
}


NuvolaKeybindingsSettings* nuvola_keybindings_settings_new (DrtgtkActions* actions_reg, NuvolaConfig* config, NuvolaActionsKeyBinder* global_keybindings) {
	return nuvola_keybindings_settings_construct (NUVOLA_TYPE_KEYBINDINGS_SETTINGS, actions_reg, config, global_keybindings);
}


static void nuvola_keybindings_settings_on_accel_edited (NuvolaKeybindingsSettings* self, const gchar* path_string, guint accel_key, GdkModifierType accel_mods, guint hardware_keycode) {
	gchar* keybinding = NULL;
	guint _tmp0_;
	GdkModifierType _tmp1_;
	gchar* _tmp2_;
	GtkTreePath* path = NULL;
	const gchar* _tmp3_;
	GtkTreePath* _tmp4_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	GtkListStore* _tmp7_;
	GtkTreeIter _tmp8_;
	guint _tmp9_;
	GdkModifierType _tmp10_;
	gchar* name = NULL;
	GtkListStore* _tmp11_;
	GtkTreeIter _tmp12_;
	guint _tmp13_;
	GdkModifierType _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	NuvolaConfig* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	DrtgtkAction* action = NULL;
	DrtgtkActions* _tmp20_;
	DrtgtkAction* _tmp21_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path_string != NULL);
	_tmp0_ = accel_key;
	_tmp1_ = accel_mods;
	_tmp2_ = gtk_accelerator_name (_tmp0_, _tmp1_);
	keybinding = _tmp2_;
	_tmp3_ = path_string;
	_tmp4_ = gtk_tree_path_new_from_string (_tmp3_);
	path = _tmp4_;
	_tmp5_ = self->priv->model;
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp5_, &_tmp6_, path);
	iter = _tmp6_;
	_tmp7_ = self->priv->model;
	_tmp8_ = iter;
	_tmp9_ = accel_key;
	_tmp10_ = accel_mods;
	gtk_list_store_set (_tmp7_, &_tmp8_, 2, _tmp9_, 3, _tmp10_, -1, -1);
	_tmp11_ = self->priv->model;
	_tmp12_ = iter;
	gtk_tree_model_get ((GtkTreeModel*) _tmp11_, &_tmp12_, 0, &name, -1, -1);
	_tmp13_ = accel_key;
	_tmp14_ = accel_mods;
	_tmp15_ = gtk_accelerator_name (_tmp13_, _tmp14_);
	_tmp16_ = _tmp15_;
	g_message ("KeybindingsSettings.vala:147: nuvola.keybindings.%s %s", name, _tmp16_);
	_g_free0 (_tmp16_);
	_tmp17_ = self->priv->config;
	_tmp18_ = g_strconcat ("nuvola.keybindings.", name, NULL);
	_tmp19_ = _tmp18_;
	drt_key_value_storage_set_string ((DrtKeyValueStorage*) _tmp17_, _tmp19_, keybinding);
	_g_free0 (_tmp19_);
	_tmp20_ = self->priv->actions_reg;
	_tmp21_ = drtgtk_actions_get_action (_tmp20_, name);
	action = _tmp21_;
	g_return_if_fail (action != NULL);
	drtgtk_action_set_keybinding (action, keybinding);
	_g_object_unref0 (action);
	_g_free0 (name);
	_gtk_tree_path_free0 (path);
	_g_free0 (keybinding);
}


static void nuvola_keybindings_settings_on_accel_cleared (NuvolaKeybindingsSettings* self, const gchar* path_string) {
	GtkTreePath* path = NULL;
	const gchar* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_;
	gchar* name = NULL;
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_;
	NuvolaConfig* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	DrtgtkAction* action = NULL;
	DrtgtkActions* _tmp11_;
	DrtgtkAction* _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path_string != NULL);
	_tmp0_ = path_string;
	_tmp1_ = gtk_tree_path_new_from_string (_tmp0_);
	path = _tmp1_;
	_tmp2_ = self->priv->model;
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp2_, &_tmp3_, path);
	iter = _tmp3_;
	_tmp4_ = self->priv->model;
	_tmp5_ = iter;
	gtk_list_store_set (_tmp4_, &_tmp5_, 2, 0, 3, 0, -1, -1);
	_tmp6_ = self->priv->model;
	_tmp7_ = iter;
	gtk_tree_model_get ((GtkTreeModel*) _tmp6_, &_tmp7_, 0, &name, -1, -1);
	_tmp8_ = self->priv->config;
	_tmp9_ = g_strconcat ("nuvola.keybindings.", name, NULL);
	_tmp10_ = _tmp9_;
	drt_key_value_storage_set_string ((DrtKeyValueStorage*) _tmp8_, _tmp10_, "");
	_g_free0 (_tmp10_);
	_tmp11_ = self->priv->actions_reg;
	_tmp12_ = drtgtk_actions_get_action (_tmp11_, name);
	action = _tmp12_;
	g_return_if_fail (action != NULL);
	drtgtk_action_set_keybinding (action, NULL);
	_g_object_unref0 (action);
	_g_free0 (name);
	_gtk_tree_path_free0 (path);
}


static void nuvola_keybindings_settings_on_glob_accel_edited (NuvolaKeybindingsSettings* self, const gchar* path_string, guint accel_key, GdkModifierType accel_mods, guint hardware_keycode) {
	gchar* keybinding = NULL;
	guint _tmp0_;
	GdkModifierType _tmp1_;
	gchar* _tmp2_;
	GtkTreePath* path = NULL;
	const gchar* _tmp3_;
	GtkTreePath* _tmp4_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	gchar* name = NULL;
	GtkListStore* _tmp8_;
	GtkTreeIter _tmp9_;
	const gchar* _tmp10_;
	guint _tmp11_;
	GdkModifierType _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	NuvolaActionsKeyBinder* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gboolean _tmp18_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path_string != NULL);
	_tmp0_ = accel_key;
	_tmp1_ = accel_mods;
	_tmp2_ = gtk_accelerator_name (_tmp0_, _tmp1_);
	keybinding = _tmp2_;
	_tmp3_ = path_string;
	_tmp4_ = gtk_tree_path_new_from_string (_tmp3_);
	path = _tmp4_;
	_tmp5_ = self->priv->model;
	_tmp6_ = path;
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp5_, &_tmp7_, _tmp6_);
	iter = _tmp7_;
	_tmp8_ = self->priv->model;
	_tmp9_ = iter;
	gtk_tree_model_get ((GtkTreeModel*) _tmp8_, &_tmp9_, 0, &name, -1, -1);
	_tmp10_ = name;
	_tmp11_ = accel_key;
	_tmp12_ = accel_mods;
	_tmp13_ = gtk_accelerator_name (_tmp11_, _tmp12_);
	_tmp14_ = _tmp13_;
	g_message ("KeybindingsSettings.vala:176: nuvola.global_keybindings.%s %s", _tmp10_, _tmp14_);
	_g_free0 (_tmp14_);
	_tmp15_ = self->priv->global_keybindings;
	_tmp16_ = name;
	_tmp17_ = keybinding;
	_tmp18_ = nuvola_actions_key_binder_set_keybinding (_tmp15_, _tmp16_, _tmp17_);
	if (_tmp18_) {
		GtkListStore* _tmp19_;
		GtkTreeIter _tmp20_;
		guint _tmp21_;
		GdkModifierType _tmp22_;
		_tmp19_ = self->priv->model;
		_tmp20_ = iter;
		_tmp21_ = accel_key;
		_tmp22_ = accel_mods;
		gtk_list_store_set (_tmp19_, &_tmp20_, 4, _tmp21_, 5, _tmp22_, -1, -1);
		nuvola_keybindings_settings_set_error (self, NULL);
	} else {
		GtkListStore* _tmp23_;
		GtkTreeIter _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		_tmp23_ = self->priv->model;
		_tmp24_ = iter;
		gtk_list_store_set (_tmp23_, &_tmp24_, 4, 0, 5, 0, -1, -1);
		_tmp25_ = keybinding;
		_tmp26_ = g_strdup_printf ("Failed to set keybinding '%s'. Make sure it is not already used by you" \
"r system or other" " programs (Google Chrome, for example).", _tmp25_);
		_tmp27_ = _tmp26_;
		nuvola_keybindings_settings_set_error (self, _tmp27_);
		_g_free0 (_tmp27_);
	}
	_g_free0 (name);
	_gtk_tree_path_free0 (path);
	_g_free0 (keybinding);
}


static void nuvola_keybindings_settings_on_glob_accel_cleared (NuvolaKeybindingsSettings* self, const gchar* path_string) {
	GtkTreePath* path = NULL;
	const gchar* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	gchar* name = NULL;
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_;
	NuvolaActionsKeyBinder* _tmp6_;
	GtkListStore* _tmp7_;
	GtkTreeIter _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path_string != NULL);
	_tmp0_ = path_string;
	_tmp1_ = gtk_tree_path_new_from_string (_tmp0_);
	path = _tmp1_;
	_tmp2_ = self->priv->model;
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp2_, &_tmp3_, path);
	iter = _tmp3_;
	_tmp4_ = self->priv->model;
	_tmp5_ = iter;
	gtk_tree_model_get ((GtkTreeModel*) _tmp4_, &_tmp5_, 0, &name, -1, -1);
	_tmp6_ = self->priv->global_keybindings;
	nuvola_actions_key_binder_set_keybinding (_tmp6_, name, NULL);
	_tmp7_ = self->priv->model;
	_tmp8_ = iter;
	gtk_list_store_set (_tmp7_, &_tmp8_, 4, 0, 5, 0, -1, -1);
	nuvola_keybindings_settings_set_error (self, NULL);
	_g_free0 (name);
	_gtk_tree_path_free0 (path);
}


static void nuvola_keybindings_settings_set_error (NuvolaKeybindingsSettings* self, const gchar* _error_) {
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _error_;
	if (_tmp0_ != NULL) {
		GtkLabel* _tmp1_;
		const gchar* _tmp2_;
		GtkInfoBar* _tmp3_;
		_tmp1_ = self->priv->error_label;
		_tmp2_ = _error_;
		gtk_label_set_label (_tmp1_, _tmp2_);
		_tmp3_ = self->priv->info_bar;
		gtk_widget_show ((GtkWidget*) _tmp3_);
	} else {
		GtkInfoBar* _tmp4_;
		_tmp4_ = self->priv->info_bar;
		gtk_widget_hide ((GtkWidget*) _tmp4_);
	}
}


static void nuvola_keybindings_settings_class_init (NuvolaKeybindingsSettingsClass * klass) {
	nuvola_keybindings_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaKeybindingsSettingsPrivate));
	G_OBJECT_CLASS (klass)->finalize = nuvola_keybindings_settings_finalize;
}


static void nuvola_keybindings_settings_instance_init (NuvolaKeybindingsSettings * self) {
	self->priv = NUVOLA_KEYBINDINGS_SETTINGS_GET_PRIVATE (self);
}


static void nuvola_keybindings_settings_finalize (GObject * obj) {
	NuvolaKeybindingsSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_KEYBINDINGS_SETTINGS, NuvolaKeybindingsSettings);
	_g_object_unref0 (self->priv->actions_reg);
	_g_object_unref0 (self->priv->config);
	_g_object_unref0 (self->priv->global_keybindings);
	_g_object_unref0 (self->priv->view);
	_g_object_unref0 (self->priv->model);
	_g_object_unref0 (self->priv->info_bar);
	_g_object_unref0 (self->priv->error_label);
	G_OBJECT_CLASS (nuvola_keybindings_settings_parent_class)->finalize (obj);
}


GType nuvola_keybindings_settings_get_type (void) {
	static volatile gsize nuvola_keybindings_settings_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_keybindings_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaKeybindingsSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_keybindings_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaKeybindingsSettings), 0, (GInstanceInitFunc) nuvola_keybindings_settings_instance_init, NULL };
		GType nuvola_keybindings_settings_type_id;
		nuvola_keybindings_settings_type_id = g_type_register_static (gtk_grid_get_type (), "NuvolaKeybindingsSettings", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_keybindings_settings_type_id__volatile, nuvola_keybindings_settings_type_id);
	}
	return nuvola_keybindings_settings_type_id__volatile;
}



