/* NetworkSettings.c generated by valac 0.38.1, the Vala compiler
 * generated from NetworkSettings.vala, do not modify */

/*
 * Copyright 2015-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>


#define NUVOLA_TYPE_NETWORK_SETTINGS (nuvola_network_settings_get_type ())
#define NUVOLA_NETWORK_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_NETWORK_SETTINGS, NuvolaNetworkSettings))
#define NUVOLA_NETWORK_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_NETWORK_SETTINGS, NuvolaNetworkSettingsClass))
#define NUVOLA_IS_NETWORK_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_NETWORK_SETTINGS))
#define NUVOLA_IS_NETWORK_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_NETWORK_SETTINGS))
#define NUVOLA_NETWORK_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_NETWORK_SETTINGS, NuvolaNetworkSettingsClass))

typedef struct _NuvolaNetworkSettings NuvolaNetworkSettings;
typedef struct _NuvolaNetworkSettingsClass NuvolaNetworkSettingsClass;
typedef struct _NuvolaNetworkSettingsPrivate NuvolaNetworkSettingsPrivate;

#define NUVOLA_TYPE_CONNECTION (nuvola_connection_get_type ())
#define NUVOLA_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_CONNECTION, NuvolaConnection))
#define NUVOLA_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_CONNECTION, NuvolaConnectionClass))
#define NUVOLA_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_CONNECTION))
#define NUVOLA_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_CONNECTION))
#define NUVOLA_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_CONNECTION, NuvolaConnectionClass))

typedef struct _NuvolaConnection NuvolaConnection;
typedef struct _NuvolaConnectionClass NuvolaConnectionClass;

#define NUVOLA_TYPE_NETWORK_PROXY_TYPE (nuvola_network_proxy_type_get_type ())
enum  {
	NUVOLA_NETWORK_SETTINGS_DUMMY_PROPERTY,
	NUVOLA_NETWORK_SETTINGS_LAST_PROPERTY
};
static GParamSpec* nuvola_network_settings_properties[NUVOLA_NETWORK_SETTINGS_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NuvolaNetworkSettings {
	GtkGrid parent_instance;
	NuvolaNetworkSettingsPrivate * priv;
};

struct _NuvolaNetworkSettingsClass {
	GtkGridClass parent_class;
};

typedef enum  {
	NUVOLA_NETWORK_PROXY_TYPE_SYSTEM,
	NUVOLA_NETWORK_PROXY_TYPE_DIRECT,
	NUVOLA_NETWORK_PROXY_TYPE_HTTP,
	NUVOLA_NETWORK_PROXY_TYPE_SOCKS
} NuvolaNetworkProxyType;

struct _NuvolaNetworkSettingsPrivate {
	NuvolaConnection* connection;
	GtkRadioButton** proxy_types;
	gint proxy_types_length1;
	gint _proxy_types_size_;
	GtkEntry* proxy_server;
	GtkSpinButton* proxy_port;
	NuvolaNetworkProxyType original_type;
	gchar* original_host;
	gint original_port;
};


static gpointer nuvola_network_settings_parent_class = NULL;

GType nuvola_network_settings_get_type (void) G_GNUC_CONST;
GType nuvola_connection_get_type (void) G_GNUC_CONST;
GType nuvola_network_proxy_type_get_type (void) G_GNUC_CONST;
#define NUVOLA_NETWORK_SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_NETWORK_SETTINGS, NuvolaNetworkSettingsPrivate))
NuvolaNetworkSettings* nuvola_network_settings_new (NuvolaConnection* connection);
NuvolaNetworkSettings* nuvola_network_settings_construct (GType object_type, NuvolaConnection* connection);
NuvolaNetworkProxyType nuvola_connection_get_network_proxy (NuvolaConnection* self, gchar* * host, gint* port);
static void nuvola_network_settings_on_proxy_type_toggled (NuvolaNetworkSettings* self, GtkToggleButton* button);
static void _nuvola_network_settings_on_proxy_type_toggled_gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void nuvola_network_settings_on_proxy_server_changed (NuvolaNetworkSettings* self);
static void _nuvola_network_settings_on_proxy_server_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self);
static void nuvola_network_settings_on_proxy_port_changed (NuvolaNetworkSettings* self);
static void _nuvola_network_settings_on_proxy_port_changed_gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self);
static void nuvola_network_settings_on_change (NuvolaNetworkSettings* self);
static inline gboolean nuvola_network_settings_is_manual_settings (NuvolaNetworkSettings* self, NuvolaNetworkProxyType type);
static NuvolaNetworkProxyType nuvola_network_settings_get_proxy_type (NuvolaNetworkSettings* self);
gboolean nuvola_network_settings_get_proxy_settings (NuvolaNetworkSettings* self, NuvolaNetworkProxyType* type, gchar* * host, gint* port);
static void nuvola_network_settings_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _nuvola_network_settings_on_proxy_type_toggled_gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	nuvola_network_settings_on_proxy_type_toggled ((NuvolaNetworkSettings*) self, _sender);
}


static void _nuvola_network_settings_on_proxy_server_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
	nuvola_network_settings_on_proxy_server_changed ((NuvolaNetworkSettings*) self);
}


static void _nuvola_network_settings_on_proxy_port_changed_gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self) {
	nuvola_network_settings_on_proxy_port_changed ((NuvolaNetworkSettings*) self);
}


NuvolaNetworkSettings* nuvola_network_settings_construct (GType object_type, NuvolaConnection* connection) {
	NuvolaNetworkSettings * self = NULL;
	NuvolaConnection* _tmp0_;
	NuvolaConnection* _tmp1_;
	NuvolaConnection* _tmp2_;
	gchar* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	NuvolaNetworkProxyType _tmp5_;
	gint row = 0;
	GtkRadioButton** _tmp6_;
	GtkRadioButton** _tmp7_;
	gint _tmp7__length1;
	GtkRadioButton* _tmp8_;
	GtkRadioButton* _tmp9_;
	GtkRadioButton** _tmp10_;
	gint _tmp10__length1;
	GtkRadioButton* _tmp11_;
	NuvolaNetworkProxyType _tmp12_;
	GtkRadioButton** _tmp15_;
	gint _tmp15__length1;
	GtkRadioButton* _tmp16_;
	gint _tmp17_;
	GtkRadioButton** _tmp18_;
	gint _tmp18__length1;
	GtkRadioButton** _tmp19_;
	gint _tmp19__length1;
	GtkRadioButton* _tmp20_;
	GSList* _tmp21_;
	GtkRadioButton* _tmp22_;
	GtkRadioButton* _tmp23_;
	GtkRadioButton** _tmp24_;
	gint _tmp24__length1;
	GtkRadioButton* _tmp25_;
	NuvolaNetworkProxyType _tmp26_;
	GtkRadioButton** _tmp29_;
	gint _tmp29__length1;
	GtkRadioButton* _tmp30_;
	gint _tmp31_;
	GtkRadioButton** _tmp32_;
	gint _tmp32__length1;
	GtkRadioButton** _tmp33_;
	gint _tmp33__length1;
	GtkRadioButton* _tmp34_;
	GSList* _tmp35_;
	GtkRadioButton* _tmp36_;
	GtkRadioButton* _tmp37_;
	GtkRadioButton** _tmp38_;
	gint _tmp38__length1;
	GtkRadioButton* _tmp39_;
	NuvolaNetworkProxyType _tmp40_;
	GtkRadioButton** _tmp43_;
	gint _tmp43__length1;
	GtkRadioButton* _tmp44_;
	gint _tmp45_;
	GtkRadioButton** _tmp46_;
	gint _tmp46__length1;
	GtkRadioButton** _tmp47_;
	gint _tmp47__length1;
	GtkRadioButton* _tmp48_;
	GSList* _tmp49_;
	GtkRadioButton* _tmp50_;
	GtkRadioButton* _tmp51_;
	GtkRadioButton** _tmp52_;
	gint _tmp52__length1;
	GtkRadioButton* _tmp53_;
	NuvolaNetworkProxyType _tmp54_;
	GtkRadioButton** _tmp57_;
	gint _tmp57__length1;
	GtkRadioButton* _tmp58_;
	gint _tmp59_;
	gboolean _tmp60_ = FALSE;
	NuvolaNetworkProxyType _tmp61_;
	gboolean manual_settings = FALSE;
	GtkLabel* label = NULL;
	GtkLabel* _tmp63_;
	GtkLabel* _tmp64_;
	gint _tmp65_;
	GtkEntry* _tmp66_;
	const gchar* _tmp67_ = NULL;
	const gchar* _tmp68_;
	GtkEntry* _tmp69_;
	GtkEntry* _tmp70_;
	gboolean _tmp71_;
	GtkEntry* _tmp72_;
	GtkEntry* _tmp73_;
	gint _tmp74_;
	GtkLabel* _tmp75_;
	GtkLabel* _tmp76_;
	gint _tmp77_;
	GtkSpinButton* _tmp78_;
	GtkSpinButton* _tmp79_;
	GtkSpinButton* _tmp80_;
	GtkSpinButton* _tmp81_;
	gint _tmp82_;
	GtkSpinButton* _tmp83_;
	gboolean _tmp84_;
	GtkSpinButton* _tmp85_;
	GtkSpinButton* _tmp86_;
	gint _tmp87_;
	GtkRadioButton** _tmp88_;
	gint _tmp88__length1;
	GtkEntry* _tmp91_;
	GtkSpinButton* _tmp92_;
	g_return_val_if_fail (connection != NULL, NULL);
	self = (NuvolaNetworkSettings*) g_object_new (object_type, NULL);
	_tmp0_ = connection;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->connection);
	self->priv->connection = _tmp1_;
	_tmp2_ = connection;
	_tmp5_ = nuvola_connection_get_network_proxy (_tmp2_, &_tmp3_, &_tmp4_);
	_g_free0 (self->priv->original_host);
	self->priv->original_host = _tmp3_;
	self->priv->original_port = _tmp4_;
	self->priv->original_type = _tmp5_;
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
	g_object_set ((GtkWidget*) self, "margin", 18, NULL);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 8);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 18);
	row = 0;
	_tmp6_ = g_new0 (GtkRadioButton*, 4 + 1);
	self->priv->proxy_types = (_vala_array_free (self->priv->proxy_types, self->priv->proxy_types_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->proxy_types = _tmp6_;
	self->priv->proxy_types_length1 = 4;
	self->priv->_proxy_types_size_ = self->priv->proxy_types_length1;
	_tmp7_ = self->priv->proxy_types;
	_tmp7__length1 = self->priv->proxy_types_length1;
	_tmp8_ = (GtkRadioButton*) gtk_radio_button_new_with_label (NULL, _ ("Use system network proxy settings"));
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (_tmp7_[0]);
	_tmp7_[0] = _tmp8_;
	_tmp9_ = _tmp7_[0];
	_tmp10_ = self->priv->proxy_types;
	_tmp10__length1 = self->priv->proxy_types_length1;
	_tmp11_ = _tmp10_[0];
	gtk_widget_set_hexpand ((GtkWidget*) _tmp11_, TRUE);
	_tmp12_ = self->priv->original_type;
	if (_tmp12_ == NUVOLA_NETWORK_PROXY_TYPE_SYSTEM) {
		GtkRadioButton** _tmp13_;
		gint _tmp13__length1;
		GtkRadioButton* _tmp14_;
		_tmp13_ = self->priv->proxy_types;
		_tmp13__length1 = self->priv->proxy_types_length1;
		_tmp14_ = _tmp13_[0];
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp14_, TRUE);
	}
	_tmp15_ = self->priv->proxy_types;
	_tmp15__length1 = self->priv->proxy_types_length1;
	_tmp16_ = _tmp15_[0];
	_tmp17_ = row;
	row = _tmp17_ + 1;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp16_, 0, _tmp17_, 3, 1);
	_tmp18_ = self->priv->proxy_types;
	_tmp18__length1 = self->priv->proxy_types_length1;
	_tmp19_ = self->priv->proxy_types;
	_tmp19__length1 = self->priv->proxy_types_length1;
	_tmp20_ = _tmp19_[0];
	_tmp21_ = gtk_radio_button_get_group (_tmp20_);
	_tmp22_ = (GtkRadioButton*) gtk_radio_button_new_with_label (_tmp21_, _ ("Use direct connection without a proxy server"));
	g_object_ref_sink (_tmp22_);
	_g_object_unref0 (_tmp18_[1]);
	_tmp18_[1] = _tmp22_;
	_tmp23_ = _tmp18_[1];
	_tmp24_ = self->priv->proxy_types;
	_tmp24__length1 = self->priv->proxy_types_length1;
	_tmp25_ = _tmp24_[1];
	gtk_widget_set_hexpand ((GtkWidget*) _tmp25_, TRUE);
	_tmp26_ = self->priv->original_type;
	if (_tmp26_ == NUVOLA_NETWORK_PROXY_TYPE_DIRECT) {
		GtkRadioButton** _tmp27_;
		gint _tmp27__length1;
		GtkRadioButton* _tmp28_;
		_tmp27_ = self->priv->proxy_types;
		_tmp27__length1 = self->priv->proxy_types_length1;
		_tmp28_ = _tmp27_[1];
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp28_, TRUE);
	}
	_tmp29_ = self->priv->proxy_types;
	_tmp29__length1 = self->priv->proxy_types_length1;
	_tmp30_ = _tmp29_[1];
	_tmp31_ = row;
	row = _tmp31_ + 1;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp30_, 0, _tmp31_, 3, 1);
	_tmp32_ = self->priv->proxy_types;
	_tmp32__length1 = self->priv->proxy_types_length1;
	_tmp33_ = self->priv->proxy_types;
	_tmp33__length1 = self->priv->proxy_types_length1;
	_tmp34_ = _tmp33_[0];
	_tmp35_ = gtk_radio_button_get_group (_tmp34_);
	_tmp36_ = (GtkRadioButton*) gtk_radio_button_new_with_label (_tmp35_, _ ("Use manual HTTP proxy settings"));
	g_object_ref_sink (_tmp36_);
	_g_object_unref0 (_tmp32_[2]);
	_tmp32_[2] = _tmp36_;
	_tmp37_ = _tmp32_[2];
	_tmp38_ = self->priv->proxy_types;
	_tmp38__length1 = self->priv->proxy_types_length1;
	_tmp39_ = _tmp38_[2];
	gtk_widget_set_hexpand ((GtkWidget*) _tmp39_, TRUE);
	_tmp40_ = self->priv->original_type;
	if (_tmp40_ == NUVOLA_NETWORK_PROXY_TYPE_HTTP) {
		GtkRadioButton** _tmp41_;
		gint _tmp41__length1;
		GtkRadioButton* _tmp42_;
		_tmp41_ = self->priv->proxy_types;
		_tmp41__length1 = self->priv->proxy_types_length1;
		_tmp42_ = _tmp41_[2];
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp42_, TRUE);
	}
	_tmp43_ = self->priv->proxy_types;
	_tmp43__length1 = self->priv->proxy_types_length1;
	_tmp44_ = _tmp43_[2];
	_tmp45_ = row;
	row = _tmp45_ + 1;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp44_, 0, _tmp45_, 3, 1);
	_tmp46_ = self->priv->proxy_types;
	_tmp46__length1 = self->priv->proxy_types_length1;
	_tmp47_ = self->priv->proxy_types;
	_tmp47__length1 = self->priv->proxy_types_length1;
	_tmp48_ = _tmp47_[0];
	_tmp49_ = gtk_radio_button_get_group (_tmp48_);
	_tmp50_ = (GtkRadioButton*) gtk_radio_button_new_with_label (_tmp49_, _ ("Use manual SOCKS proxy settings"));
	g_object_ref_sink (_tmp50_);
	_g_object_unref0 (_tmp46_[3]);
	_tmp46_[3] = _tmp50_;
	_tmp51_ = _tmp46_[3];
	_tmp52_ = self->priv->proxy_types;
	_tmp52__length1 = self->priv->proxy_types_length1;
	_tmp53_ = _tmp52_[3];
	gtk_widget_set_hexpand ((GtkWidget*) _tmp53_, TRUE);
	_tmp54_ = self->priv->original_type;
	if (_tmp54_ == NUVOLA_NETWORK_PROXY_TYPE_SOCKS) {
		GtkRadioButton** _tmp55_;
		gint _tmp55__length1;
		GtkRadioButton* _tmp56_;
		_tmp55_ = self->priv->proxy_types;
		_tmp55__length1 = self->priv->proxy_types_length1;
		_tmp56_ = _tmp55_[3];
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp56_, TRUE);
	}
	_tmp57_ = self->priv->proxy_types;
	_tmp57__length1 = self->priv->proxy_types_length1;
	_tmp58_ = _tmp57_[3];
	_tmp59_ = row;
	row = _tmp59_ + 1;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp58_, 0, _tmp59_, 3, 1);
	_tmp61_ = self->priv->original_type;
	if (_tmp61_ == NUVOLA_NETWORK_PROXY_TYPE_HTTP) {
		_tmp60_ = TRUE;
	} else {
		NuvolaNetworkProxyType _tmp62_;
		_tmp62_ = self->priv->original_type;
		_tmp60_ = _tmp62_ == NUVOLA_NETWORK_PROXY_TYPE_SOCKS;
	}
	manual_settings = _tmp60_;
	_tmp63_ = (GtkLabel*) gtk_label_new (_ ("Proxy Server"));
	g_object_ref_sink (_tmp63_);
	label = _tmp63_;
	_tmp64_ = label;
	_tmp65_ = row;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp64_, 0, _tmp65_, 1, 1);
	_tmp66_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp66_);
	_g_object_unref0 (self->priv->proxy_server);
	self->priv->proxy_server = _tmp66_;
	_tmp68_ = self->priv->original_host;
	_tmp67_ = _tmp68_;
	if (_tmp67_ == NULL) {
		_tmp67_ = "";
	}
	_tmp69_ = self->priv->proxy_server;
	gtk_entry_set_text (_tmp69_, _tmp67_);
	_tmp70_ = self->priv->proxy_server;
	_tmp71_ = manual_settings;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp70_, _tmp71_);
	_tmp72_ = self->priv->proxy_server;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp72_, TRUE);
	_tmp73_ = self->priv->proxy_server;
	_tmp74_ = row;
	row = _tmp74_ + 1;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp73_, 1, _tmp74_, 2, 1);
	_tmp75_ = (GtkLabel*) gtk_label_new (_ ("Proxy Server Port"));
	g_object_ref_sink (_tmp75_);
	_g_object_unref0 (label);
	label = _tmp75_;
	_tmp76_ = label;
	_tmp77_ = row;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp76_, 0, _tmp77_, 1, 1);
	_tmp78_ = (GtkSpinButton*) gtk_spin_button_new_with_range (0.0, (gdouble) G_MAXINT32, 1.0);
	g_object_ref_sink (_tmp78_);
	_g_object_unref0 (self->priv->proxy_port);
	self->priv->proxy_port = _tmp78_;
	_tmp79_ = self->priv->proxy_port;
	gtk_spin_button_set_digits (_tmp79_, (guint) 0);
	_tmp80_ = self->priv->proxy_port;
	gtk_spin_button_set_snap_to_ticks (_tmp80_, TRUE);
	_tmp81_ = self->priv->proxy_port;
	_tmp82_ = self->priv->original_port;
	gtk_spin_button_set_value (_tmp81_, (gdouble) _tmp82_);
	_tmp83_ = self->priv->proxy_port;
	_tmp84_ = manual_settings;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp83_, _tmp84_);
	_tmp85_ = self->priv->proxy_port;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp85_, TRUE);
	_tmp86_ = self->priv->proxy_port;
	_tmp87_ = row;
	row = _tmp87_ + 1;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp86_, 1, _tmp87_, 2, 1);
	_tmp88_ = self->priv->proxy_types;
	_tmp88__length1 = self->priv->proxy_types_length1;
	{
		GtkRadioButton** t_collection = NULL;
		gint t_collection_length1 = 0;
		gint _t_collection_size_ = 0;
		gint t_it = 0;
		t_collection = _tmp88_;
		t_collection_length1 = _tmp88__length1;
		for (t_it = 0; t_it < _tmp88__length1; t_it = t_it + 1) {
			GtkRadioButton* _tmp89_;
			GtkRadioButton* t = NULL;
			_tmp89_ = _g_object_ref0 (t_collection[t_it]);
			t = _tmp89_;
			{
				GtkRadioButton* _tmp90_;
				_tmp90_ = t;
				g_signal_connect_object ((GtkToggleButton*) _tmp90_, "toggled", (GCallback) _nuvola_network_settings_on_proxy_type_toggled_gtk_toggle_button_toggled, self, 0);
				_g_object_unref0 (t);
			}
		}
	}
	_tmp91_ = self->priv->proxy_server;
	g_signal_connect_object ((GtkEditable*) _tmp91_, "changed", (GCallback) _nuvola_network_settings_on_proxy_server_changed_gtk_editable_changed, self, 0);
	_tmp92_ = self->priv->proxy_port;
	g_signal_connect_object (_tmp92_, "value-changed", (GCallback) _nuvola_network_settings_on_proxy_port_changed_gtk_spin_button_value_changed, self, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (label);
	return self;
}


NuvolaNetworkSettings* nuvola_network_settings_new (NuvolaConnection* connection) {
	return nuvola_network_settings_construct (NUVOLA_TYPE_NETWORK_SETTINGS, connection);
}


static void nuvola_network_settings_on_change (NuvolaNetworkSettings* self) {
	GtkEntry* _tmp0_;
	GtkSpinButton* _tmp1_;
	NuvolaNetworkProxyType _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->proxy_server;
	_tmp1_ = self->priv->proxy_port;
	_tmp2_ = nuvola_network_settings_get_proxy_type (self);
	_tmp3_ = nuvola_network_settings_is_manual_settings (self, _tmp2_);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, _tmp3_);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp3_);
}


static inline gboolean nuvola_network_settings_is_manual_settings (NuvolaNetworkSettings* self, NuvolaNetworkProxyType type) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	NuvolaNetworkProxyType _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = type;
	if (_tmp1_ == NUVOLA_NETWORK_PROXY_TYPE_HTTP) {
		_tmp0_ = TRUE;
	} else {
		NuvolaNetworkProxyType _tmp2_;
		_tmp2_ = type;
		_tmp0_ = _tmp2_ == NUVOLA_NETWORK_PROXY_TYPE_SOCKS;
	}
	result = _tmp0_;
	return result;
}


static NuvolaNetworkProxyType nuvola_network_settings_get_proxy_type (NuvolaNetworkSettings* self) {
	NuvolaNetworkProxyType result = 0;
	NuvolaNetworkProxyType type = 0;
	GtkRadioButton** _tmp0_;
	gint _tmp0__length1;
	GtkRadioButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, 0);
	type = NUVOLA_NETWORK_PROXY_TYPE_SYSTEM;
	_tmp0_ = self->priv->proxy_types;
	_tmp0__length1 = self->priv->proxy_types_length1;
	_tmp1_ = _tmp0_[0];
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		type = NUVOLA_NETWORK_PROXY_TYPE_SYSTEM;
	} else {
		GtkRadioButton** _tmp4_;
		gint _tmp4__length1;
		GtkRadioButton* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp4_ = self->priv->proxy_types;
		_tmp4__length1 = self->priv->proxy_types_length1;
		_tmp5_ = _tmp4_[1];
		_tmp6_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp5_);
		_tmp7_ = _tmp6_;
		if (_tmp7_) {
			type = NUVOLA_NETWORK_PROXY_TYPE_DIRECT;
		} else {
			GtkRadioButton** _tmp8_;
			gint _tmp8__length1;
			GtkRadioButton* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
			_tmp8_ = self->priv->proxy_types;
			_tmp8__length1 = self->priv->proxy_types_length1;
			_tmp9_ = _tmp8_[2];
			_tmp10_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp9_);
			_tmp11_ = _tmp10_;
			if (_tmp11_) {
				type = NUVOLA_NETWORK_PROXY_TYPE_HTTP;
			} else {
				GtkRadioButton** _tmp12_;
				gint _tmp12__length1;
				GtkRadioButton* _tmp13_;
				gboolean _tmp14_;
				gboolean _tmp15_;
				_tmp12_ = self->priv->proxy_types;
				_tmp12__length1 = self->priv->proxy_types_length1;
				_tmp13_ = _tmp12_[3];
				_tmp14_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp13_);
				_tmp15_ = _tmp14_;
				if (_tmp15_) {
					type = NUVOLA_NETWORK_PROXY_TYPE_SOCKS;
				}
			}
		}
	}
	result = type;
	return result;
}


gboolean nuvola_network_settings_get_proxy_settings (NuvolaNetworkSettings* self, NuvolaNetworkProxyType* type, gchar* * host, gint* port) {
	NuvolaNetworkProxyType _vala_type = 0;
	gchar* _vala_host = NULL;
	gint _vala_port = 0;
	gboolean result = FALSE;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkSpinButton* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	NuvolaNetworkProxyType _tmp8_;
	gboolean changed = FALSE;
	NuvolaNetworkProxyType _tmp9_;
	NuvolaNetworkProxyType _tmp10_;
	gboolean _tmp11_ = FALSE;
	NuvolaNetworkProxyType _tmp12_;
	gboolean _tmp13_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->proxy_server;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (_vala_host);
	_vala_host = _tmp3_;
	_tmp4_ = _vala_host;
	if (g_strcmp0 (_tmp4_, "") == 0) {
		_g_free0 (_vala_host);
		_vala_host = NULL;
	}
	_tmp5_ = self->priv->proxy_port;
	_tmp6_ = gtk_spin_button_get_value (_tmp5_);
	_tmp7_ = _tmp6_;
	_vala_port = (gint) _tmp7_;
	_tmp8_ = nuvola_network_settings_get_proxy_type (self);
	_vala_type = _tmp8_;
	_tmp9_ = _vala_type;
	_tmp10_ = self->priv->original_type;
	changed = _tmp9_ != _tmp10_;
	_tmp12_ = _vala_type;
	_tmp13_ = nuvola_network_settings_is_manual_settings (self, _tmp12_);
	if (_tmp13_) {
		gboolean _tmp14_;
		_tmp14_ = changed;
		_tmp11_ = !_tmp14_;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		gboolean _tmp15_ = FALSE;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		_tmp16_ = _vala_host;
		_tmp17_ = self->priv->original_host;
		if (g_strcmp0 (_tmp16_, _tmp17_) != 0) {
			_tmp15_ = TRUE;
		} else {
			gint _tmp18_;
			gint _tmp19_;
			_tmp18_ = _vala_port;
			_tmp19_ = self->priv->original_port;
			_tmp15_ = _tmp18_ != _tmp19_;
		}
		changed = _tmp15_;
	}
	result = changed;
	if (type) {
		*type = _vala_type;
	}
	if (host) {
		*host = _vala_host;
	} else {
		_g_free0 (_vala_host);
	}
	if (port) {
		*port = _vala_port;
	}
	return result;
}


static void nuvola_network_settings_on_proxy_type_toggled (NuvolaNetworkSettings* self, GtkToggleButton* button) {
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (button != NULL);
	_tmp0_ = button;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		nuvola_network_settings_on_change (self);
	}
}


static void nuvola_network_settings_on_proxy_server_changed (NuvolaNetworkSettings* self) {
	g_return_if_fail (self != NULL);
	nuvola_network_settings_on_change (self);
}


static void nuvola_network_settings_on_proxy_port_changed (NuvolaNetworkSettings* self) {
	g_return_if_fail (self != NULL);
	nuvola_network_settings_on_change (self);
}


static void nuvola_network_settings_class_init (NuvolaNetworkSettingsClass * klass) {
	nuvola_network_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaNetworkSettingsPrivate));
	G_OBJECT_CLASS (klass)->finalize = nuvola_network_settings_finalize;
}


static void nuvola_network_settings_instance_init (NuvolaNetworkSettings * self) {
	self->priv = NUVOLA_NETWORK_SETTINGS_GET_PRIVATE (self);
}


static void nuvola_network_settings_finalize (GObject * obj) {
	NuvolaNetworkSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_NETWORK_SETTINGS, NuvolaNetworkSettings);
	_g_object_unref0 (self->priv->connection);
	self->priv->proxy_types = (_vala_array_free (self->priv->proxy_types, self->priv->proxy_types_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (self->priv->proxy_server);
	_g_object_unref0 (self->priv->proxy_port);
	_g_free0 (self->priv->original_host);
	G_OBJECT_CLASS (nuvola_network_settings_parent_class)->finalize (obj);
}


GType nuvola_network_settings_get_type (void) {
	static volatile gsize nuvola_network_settings_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_network_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaNetworkSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_network_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaNetworkSettings), 0, (GInstanceInitFunc) nuvola_network_settings_instance_init, NULL };
		GType nuvola_network_settings_type_id;
		nuvola_network_settings_type_id = g_type_register_static (gtk_grid_get_type (), "NuvolaNetworkSettings", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_network_settings_type_id__volatile, nuvola_network_settings_type_id);
	}
	return nuvola_network_settings_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



